#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#
#   Copyright (c) 2007 Urho Konttori <urho.konttori@gmail.com>
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
#   02111-1307, USA.
#

import pygame, os
from pygame.locals import *



os.environ["SDL_VIDEO_X11_WMCLASS"]="ukmp"

ISMAEMO=0
NOT_MAC=False
if os.name=="posix" and os.path.exists('/media/mmc1'): 
    ISMAEMO=1
    NOT_MAC=True

if NOT_MAC:
    import gst,pygst

if ISMAEMO == 1:    
    import osso
    #import gobject
    
    try:
        osso_c = osso.Context("ukmp", "1.0", False)        
        # Turn the backlight on (for convinience if you are running this remotely from SSH shell)
        device = osso.DeviceState(osso_c)
        device.display_state_on()
        osso_rpc = osso.Rpc(osso_c)
        import dbus
        import dbus.glib
        import dbus.service
    except:
        print "OSSO CONTEXT FAILED"    



SCREENRECT = Rect(0, 0, 800, 480)
THUMBNAIL_SIZE = [160, 160]
ALBUMSPACEWIDTH=180#143
ALBUMWIDTH=180
ALBUMYSCROLL=180
VIDEOCOVERWIDTH=180
ALBUMHEIGHT=200

MAINFONTCOLOR=240,240,240
ALTFONTCOLOR=0,0,0
MAINFONTBGCOLOR=0,0,0
MAINTRANSPARENTCOLOR=255,0,0
SMOOTHSCROLLENABLED=True
VIDEOSMOOTHSCROLLENABLED=True
SCROLLENABLED=True
SONGLISTSTARTY=310
SONGLISTSTARTX=280
SHINEX=0
SHINEY=0
SHINEVX=0
SHINEVY=0

pilImported=False

songPosition=0

pygame.init()
pygame.display.set_caption('ukmp')
if NOT_MAC: pygame.mixer.quit() 


if os.name=="posix" and os.path.exists('/media/mmc1'): ISMAEMO=1
winstyle = 1
if ISMAEMO: winstyle = FULLSCREEN
bestdepth = pygame.display.mode_ok(SCREENRECT.size, winstyle, 16)
if not ISMAEMO: bestdepth = pygame.display.mode_ok(SCREENRECT.size, winstyle, 32)
screen = pygame.display.set_mode(SCREENRECT.size, winstyle, bestdepth)
if ISMAEMO: pygame.mouse.set_visible(False)


import  random,os,urllib,time,string, shutil,math, sys, time, gc

import id3reader
from ID3 import *
from PyAtom import *


# View constants
PLAYPOSSIBLE=0

volume=8.0
shuffleClicked=0
socketOk=True


lastSongPosition=0
currentAlbumSongCount=0
# TODO: Add UI for turning this on/off
keepBacklightOn=False



ALBUMNAMESTARTX=170
ALBUMNAMESTARTY=410

ALBUMCOVERSTARTY=475
ALBUMCOVERSTARTX=640

IMAGECACHINUSE=False
mouseReleased=0
lastMouseReleased=0

MEDIA_TYPE_UNKNOWN = 0
MEDIA_TYPE_AUDIO   = 1
MEDIA_TYPE_VIDEO   = 2

FORMAT_UNKNOWN   = 0
FORMAT_AUDIO_MP3 = 1
FORMAT_AUDIO_M4A = 2
FORMAT_AUDIO_OGG = 3
FORMAT_AUDIO_WMA = 4
FORMAT_AUDIO_AAC = 5
FORMAT_VIDEO_AVI = 1000
FORMAT_VIDEO_FLV = 1001
FORMAT_VIDEO_MOV = 1002
FORMAT_VIDEO_3GP = 1003
# TODO: Test before adding
FORMAT_VIDEO_M4V = 1004

CLICKMODE=0
CLICK_PLAYNOW=0
CLICK_QUEUE=1
CLICK_PLAYLIST=2
CLICK_DELETE=3

BME_REQ_PATH="/com/nokia/bme/request"
BME_REQ_IFC ="com.nokia.bme.request"
mainfont = pygame.font.Font(None,22)

def getMediaTypeFromFileName(fileName):
    if fileName.find('.')== 0:
        return MEDIA_TYPE_UNKNOWN

    if fileName.endswith(".mp3") or fileName.endswith(".MP3") or fileName.endswith(".m4a") or fileName.endswith(".M4A") or fileName.endswith(".ogg") or fileName.endswith(".OGG") or fileName.endswith(".wma") or fileName.endswith(".WMA") or fileName.endswith(".aac") or fileName.endswith(".AAC"):
        return MEDIA_TYPE_AUDIO

    elif fileName.endswith(".mp4") or fileName.endswith(".avi") or fileName.endswith(".asf") or fileName.endswith(".AVI") or fileName.endswith(".flv") or fileName.endswith(".FLV")or fileName.endswith(".mov") or fileName.endswith(".MOV") or fileName.endswith(".3gp") or fileName.endswith(".3GP") or fileName.endswith(".m4v"):
        return MEDIA_TYPE_VIDEO
    return MEDIA_TYPE_UNKNOWN



#ogg support by Neil Jerram
def ogg_comment_value(block, tag):
   comment_pos = block.find(tag)
   if (comment_pos >= 4):
       comment_len = ord(block[comment_pos - 4])
       comment_val = block[comment_pos + len(tag) : comment_pos + comment_len]
   else:
       comment_val = ''
   return comment_val

def get_ogg_comments(file_name):
   f = open(file_name, 'r')
   block = f.read(1024)
   f.close()

   title = ogg_comment_value(block, 'TITLE=')
   artist = ogg_comment_value(block, 'ARTIST=')
   tracknumber = ogg_comment_value(block, 'TRACKNUMBER=')
   album = ogg_comment_value(block, 'ALBUM=')

   return [title, artist, tracknumber, album]


#THESE SHOULD BE CHANGED TO USE LOWER CASE VERSION OF FILENAME
def getFormatFromFileName(fileName):
    if fileName.find('.')== 0:
        return FORMAT_UNKNOWN

    if fileName.endswith(".mp3") or fileName.endswith(".MP3"):
        return FORMAT_AUDIO_MP3
    elif fileName.endswith(".m4a") or fileName.endswith(".M4A"):
        return FORMAT_AUDIO_M4A
    elif fileName.endswith(".ogg") or fileName.endswith(".OGG"):
        return FORMAT_AUDIO_OGG
    elif fileName.endswith(".wma") or fileName.endswith(".WMA"):
        return FORMAT_AUDIO_WMA
    elif fileName.endswith(".aac") or fileName.endswith(".AAC"):
        return FORMAT_AUDIO_AAC
    elif fileName.endswith(".avi") or fileName.endswith(".AVI") or fileName.endswith(".asf"):
        return FORMAT_VIDEO_AVI
    elif fileName.endswith(".flv") or fileName.endswith(".FLV"):
        return FORMAT_VIDEO_FLV
    elif fileName.endswith(".mov") or fileName.endswith(".MOV"):
        return FORMAT_VIDEO_MOV
    
    elif fileName.endswith(".mp4") or fileName.endswith(".mp4"):
        return FORMAT_VIDEO_MOV
    
    elif fileName.endswith(".3gp") or fileName.endswith(".3GP"):
        return FORMAT_VIDEO_3GP
    # TODO: Test before adding
    elif fileName.endswith(".m4v") or fileName.endswith(".M4V"):
           return FORMAT_VIDEO_M4V

    return FORMAT_UNKNOWN




coverlocation="data/covers/"
if ISMAEMO==1:
    coverlocation="/media/mmc1/covers/"
if not os.path.exists(coverlocation):
    try:
        if not os.path.exists(coverlocation):
            os.makedirs(coverlocation)
    except OSError, message:
        print message
        coverlocation='/media/mmc2/covers/'
        try:
            if not os.path.exists(coverlocation):
                os.makedirs(coverlocation)
        except OSError, message:
            coverlocation='~/covers'
            if not os.path.exists(coverlocation):
                os.makedirs(coverlocation)



selectedCD=-1
shuffle=False
albumlist=[]
filelist=[]
artistlist=[]
songlist=[]
albumart=[]
artArray=[]
albumArray=[]
albumArtistArray=[]
clipList=[]
clipArray=[]
arrowPressed=0
startX=0
mouseMoved=0
mouseYMoved=0
artDragXStart=0

speedModifier=1



ALBUMLISTVIEW=1
ALBUMCONTENTVIEW=2
ALBUMPLAYVIEW=3
VIDEOLISTVIEW=10

viewMode=ALBUMLISTVIEW
viewModeToBe=ALBUMLISTVIEW
cdClicked=0
buttonPressed=0
songItems=[]
activeCD=-1
nowPlayingAlbum=0
nowShowingAlbum=0
nowPlayingSongName=""
nowPlayingAlbumName=""
nowPlayingArtistName=""
nowPlayingSongId=-1
playSelected=False
selectedArtArrayId=0


def getCoverArtThumbFileName( album ):
    """Returns the cover art's thumbnail filename that is formed from the album name."""
    thumbFile=string.replace(album," ","_")
    thumbFile=fixFileString(thumbFile)
    thumbFile=coverlocation+thumbFile+"_thumb.jpg"
    try:
        thumbFile=unicode(thumbFile,'utf8').encode('utf8', 'ignore')
    except:
        try:
            thumbFile=unicode(thumbFile,'latin-1').encode('ascii', 'ignore')
        except:
            pass
    return thumbFile

def getCoverArtFileName( album ):
    """Returns the full cover art's filename that is formed from the album name."""
    thumbFile=string.replace(album," ","_")
    thumbFile=fixFileString(thumbFile)
    thumbFile=coverlocation+thumbFile+".jpg"
    try:
        thumbFile=unicode(thumbFile,'utf8').encode('utf8', 'ignore')
    except:
        try:
            thumbFile=unicode(thumbFile,'latin-1').encode('ascii', 'ignore')
        except:
            pass
    return thumbFile

def updateScrobbler():    
    osso_rpc.rpc_run(
 	        "com.nokia.songlistend",
 	        "/com/nokia/songlistend",
 	        "com.nokia.songlistend",
 	        "playing",
    makeScrobblerArgs(),
    wait_reply = False)
    print "info sent to scrobbler"

def makeScrobblerArgs():
    global nowPlayingAlbumName, nowPlayingArtistName, nowPlayingSongName
    
    rpc_args = (
        str(nowPlayingArtistName),
        str(nowPlayingSongName),
        str(nowPlayingAlbumName),
        int(120), #Length
        int(0))
    
    return rpc_args

def load_sound(filename):
    #filename = os.path.join('music', filename)
    return pygame.mixer.Sound(filename)


def isCompilation(album):
    global songlist
    global albumlist
    j=0
    i=0

    artistName=""
    for artist in artistlist:
        if (albumlist[i]==album):
            if len(artistName)>1 and not (artistName==artistlist[i]):
                return True
            if len(artistName)>1:
                return False
            artistName=artistlist[i]
            if artistName=="VA" or artistName=="Va":
                return True
            j=j+1
        i=i+1


def fixFileString( fs):
    fs=str(fs)
    fs=string.replace(fs," ","_")
    fs=string.replace(fs,"/","-")
    fs=string.replace(fs,":","_")
    fs=string.replace(fs,"?","_")
    fs=string.replace(fs,"%","")
    fs=string.replace(fs,"~","-")
    fs=string.replace(fs,",","-")
    fs=string.replace(fs,"*","-")
    fs=string.replace(fs,"&","-")
    fs=string.replace(fs,">","-")
    fs=string.replace(fs,"<","-")
    fs=string.replace(fs,".","-")
    fs=string.replace(fs,"(","")
    fs=string.replace(fs,")","")
    fs=string.replace(fs,'"',"")
    fs=string.replace(fs,str(0xe4),"_")
    return fs


def imgcolorkey(image, colorkey):
    if colorkey is not None:
        if colorkey is -1:
        #colorkey = image.get_at((0, 0))
            colorkey=(255,0,0)
        image.set_colorkey(colorkey, pygame.RLEACCEL)
    else:
        image.set_colorkey(None, pygame.RLEACCEL)
    return image

def load_image(filename, colorkey =None):
    f=""
    
    if (os.path.exists(filename)):
        try:
            f=open(filename)
        except:
            print "load_image(): Problem opening file:" + filename
        if (f==""): filename=string.replace(filename," ","_")
        try:
            image = pygame.image.load(filename).convert()
        except:
            print "load_image(): Problem opening file (2):"+filename
            if (os.path.exists("/usr/share/pixmaps/UNKNOWN_UNKNOWN.jpg")):
                image = pygame.image.load("/usr/share/pixmaps/UNKNOWN_UNKNOWN.jpg").convert()
            else:
                image = pygame.image.load("data/covers/UNKNOWN_UNKNOWN.jpg").convert()
    else:
        print "File does not exist:" + filename
        if (os.path.exists("/usr/share/pixmaps/UNKNOWN_UNKNOWN.jpg")):
            image = pygame.image.load("/usr/share/pixmaps/UNKNOWN_UNKNOWN.jpg").convert()
        else:    
            try:        
                image = pygame.image.load("data/covers/UNKNOWN_UNKNOWN.jpg").convert()
            except:
                print "Problem opening unknown file."

    return  imgcolorkey(image, colorkey)
    #return image

class SpriteSheet:
    def __init__(self, filename):
        if (os.path.exists(filename)):
            self.sheet = load_image(filename)
    def imgat(self, rect, colorkey = None):
        rect = Rect(rect)
        image = pygame.Surface(rect.size)
        image.blit(self.sheet, (0, 0), rect)

        colorkey=255,0,0
        return imgcolorkey(image, colorkey)

    def imgsat(self, rects, colorkey = None):
        imgs = []
        for rect in rects:
            imgs.append(self.imgat(rect, colorkey))
        return imgs


if ISMAEMO == 1:
    class BMERequest(dbus.service.Object):
        def __init__(self, bus_name, object_path=BME_REQ_PATH):
            dbus.service.Object.__init__(self, bus_name, object_path)            
        @dbus.service.signal(BME_REQ_IFC)        
        def status_info_req(self):
            print "sent"

class BatteryMonitor:
    
    def __init__(self):
        self.bus = dbus.SystemBus(private=True)
        self.bus.add_signal_receiver(self.handle_charging_off,"charger_charging_off")
        self.bus.add_signal_receiver(self.handle_charging_on ,"charger_charging_on" )
        name = dbus.service.BusName(BME_REQ_IFC, bus=self.bus)
        e = BMERequest(name)
        e.status_info_req()
        print "monitor added"

    def handle_charging_on(self,sender=None):
        print "charging"
        manager.on_battery = False
        manager.update_power()
    
    def handle_charging_off(self,sender=None):
        print "on_battery"
        manager.on_battery = True
        manager.update_powersave()



class SongList(pygame.sprite.Sprite):

    def __init__(self, mainbg,songItems):
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.rect = self.image.get_rect()
        self.mainbg = mainbg
        self.songQueue=[]
        self.playedList=[]
        self.previousFile=""
        self.songItems=songItems
        self.rect.top = 172
        self.rect.left = 20
        self.lastAlbum=" "
        self.bgupdated=0
        self.counter=0
        self.currentPlayId=0
        self.albumId=0
        self.playing = False
        self.playOn=0
        self.player_clean=True
        if NOT_MAC:
            self.createGSTPlayer()

        self.currentPlayIndex=0
        self.playOn=0
        self.currentAlbumFileList=[]
        self.displayedAlbumFileList=[]

    def createGSTPlayer(self):
        self.player = gst.element_factory_make("playbin", "player")
        
    def createGSTPlayerOld(self):
        if ISMAEMO == 0:
            self.player = gst.parse_launch( "gnomevfssrc name=source ! mad name=id3 ! alsasink name=sink" )
        else:
            try:
                self.player = gst.parse_launch( "gnomevfssrc name=source ! id3demux name=id3 ! dspmp3sink name=sink" )
            except:
                self.player = gst.parse_launch( "gnomevfssrc name=source ! id3lib name=id3 ! dspmp3sink name=sink" )
            
        self.source = self.player.get_by_name( "source" )
        self.sink = self.player.get_by_name( "sink" )
        self.id3 = self.player.get_by_name( "id3" )
        self.player.set_name("player")

    def createGSTM4APlayer(self):
        self.player = gst.parse_launch( "gnomevfssrc name=source ! demux3gp name=demuxer ! dspaacsink name=sink sync=false" )
        self.source = self.player.get_by_name( "source" )
        self.sink = self.player.get_by_name( "sink" )
        self.player.set_name("player")

    def createGSTAACPlayer(self):
        self.player = gst.parse_launch( "gnomevfssrc name=source ! dspaacsink name=sink" )
        self.source = self.player.get_by_name( "source" )
        self.sink = self.player.get_by_name( "sink" )
        self.player.set_name("player")


    def createGSTOGGPlayer(self):
        #self.player = gst.parse_launch( "gnomevfssrc name=source ! tremor name=decoder ! dsppcmsink name=sink" )
        if ISMAEMO == 1:
            self.player = gst.parse_launch( "gnomevfssrc name=source ! oggdemux name=demuxer ! ivorbisdec name=decoder ! dsppcmsink name=sink" )
        else:
            self.player = gst.parse_launch( "gnomevfssrc name=source ! oggdemux ! vorbisdec ! audioconvert ! audioresample ! alsasink name=sink")

        self.source = self.player.get_by_name( "source" )
        self.sink = self.player.get_by_name( "sink" )
        self.player.set_name("player")

    def createGSTWMAPlayer(self):
        #self.player = gst.parse_launch( "gnomevfssrc name=source ! tremor name=decoder ! dsppcmsink name=sink" )
        self.player = gst.parse_launch( "gnomevfssrc name=source ! fluasfdemux name=demuxer  ! fluwmadec name=decoder ! dsppcmsink name=sink" )

        self.source = self.player.get_by_name( "source" )
        self.sink = self.player.get_by_name( "sink" )
        self.player.set_name("player")


    def demuxer_callback(self, demuxer, pad):
        print "demuxer callback"+pad
        self.player_clean=False

    def setAlbum(self, givenimage, artist, album, albumId):
        global listButton
        global albumButton
        global currentAlbumSongCount
        
        print "### setting album " + album 
        self.image.blit(self.background, (0, 0))
        self.bgupdated=1
        font = pygame.font.Font(None,38)
        
        self.test=font.render(artist+ " - "+ album, 1, MAINFONTCOLOR)        
        self.image.blit(self.test, (0, 0))
                
        self.albumId=albumId
        artArray[self.albumId].setSelected()
        listButton.setVisible()
        listButton.update()
        k=0
        while k<30:
            visible.remove(songItems[k])
            k=k+1

        songArray=[]
        sortArray=[]
        idArray=[]
        self.displayedAlbumFileList=[]
        if self.albumId==nowPlayingAlbum:
            self.currentAlbumFileList=[]

        i=0
        j=0
        for song in songlist:
            if (albumlist[i]==album and j<30):
                self.displayedAlbumFileList.append(filelist[i])
                #self.songItems[j].setSong(song, i)                
                sortArray.append(song)
                songArray.append(song)
                idArray.append(i)
                j=j+1
            i=i+1
        self.lastAlbum=album
        currentAlbumSongCount=j
        #SORT THE SONGS BY SONG NAME
        sortArray.sort()

        i=0
        for sorted in sortArray:
            j=0
            for song in songArray:
                if (sorted==song and not i==j):
                    temp=songArray[j]
                    songArray[j]=songArray[i]
                    songArray[i]=temp
                    temp2=self.displayedAlbumFileList[j]
                    self.displayedAlbumFileList[j]=self.displayedAlbumFileList[i]
                    self.displayedAlbumFileList[i]=temp2
                    temp3=idArray[j]
                    idArray[j]=idArray[i]
                    idArray[i]=temp3
                j=j+1
            i=i+1

        i=0
        for sorted in songArray:
            self.songItems[i].setSong(sorted, idArray[i])
            visible.add(songItems[i])
            print self.displayedAlbumFileList[i] +"song:" + self.songItems[i].song
            i=i+1
        i=0
        if self.albumId==nowPlayingAlbum:
            for filename in self.displayedAlbumFileList:
                self.currentAlbumFileList.append(filename)
                #print filename+" " + self.songItems[i].song
                i=i+1

        if (viewModeToBe==ALBUMCONTENTVIEW):
            visible.add(listButton)
            listButton.setVisible()
            listButton.update()

    def getPosition(self):
        position=0
        value=0
        if NOT_MAC:
            try:
                position, format = self.player.query_position(gst.FORMAT_TIME)
            except:
                position = gst.CLOCK_TIME_NONE
            if position != gst.CLOCK_TIME_NONE:
                value=position

        else:
            position=pygame.mixer.music.get_pos()
        return value

    def format_time(self, time):
        hour = str(int(time)/3600)
        minute = int(time)/60%60
        if minute < 10:
            minute = "0" + str(minute)
        else:
            minute = str(minute)
        seconds = int(time)%60
        if seconds < 10:
            seconds = "0" + str(seconds)
        else:
            seconds = str(seconds)
        return hour + ":" + minute + ":" + seconds
    
    def getSongLengthString(self):
        if NOT_MAC:
            try:
                duration, format = self.player.query_duration(gst.FORMAT_TIME)
            except:
                duration = gst.CLOCK_TIME_NONE
            if duration != gst.CLOCK_TIME_NONE:
                durationClean=duration/gst.MSECOND
                return str(self.format_time(durationClean/1000))                        
        return "??:??:??"
    
    def getSongPositionString(self):
        if NOT_MAC:
            try:
                position, format = self.player.query_position(gst.FORMAT_TIME)
            except:
                position = gst.CLOCK_TIME_NONE
            if position != gst.CLOCK_TIME_NONE:
                positionClean=position/gst.MSECOND
                return str(self.format_time(positionClean/1000))                        
        return "??:??:??"
            
        
    def setPercentPosition(self, position):
        if NOT_MAC:
            try:
                duration, format = self.player.query_duration(gst.FORMAT_TIME)
            except:
                duration = gst.CLOCK_TIME_NONE
            if duration != gst.CLOCK_TIME_NONE:
                durationClean=duration/gst.MSECOND
                print "duration: " + str(self.format_time(durationClean/1000))
                print "position: " + str(position)
                print "place:" + str((position*duration)/100)
                self.seek ((position*duration)/100)
        else:
            print "seek not supported " + str(position)
            #pygame.mixer.music.get_busy()
        

    def getPercentPosition(self):
        position=0
        value=0
        if NOT_MAC:
            try:
                position, format = self.player.query_position(gst.FORMAT_TIME)
            except:
                position = gst.CLOCK_TIME_NONE
            try:
                duration, format = self.player.query_duration(gst.FORMAT_TIME)
            except:
                duration = gst.CLOCK_TIME_NONE
            if position != gst.CLOCK_TIME_NONE:
                value = position * 100.0 / duration
        else:
            position=pygame.mixer.music.get_pos()
            #pygame.mixer.music.get_busy()
        return value
    
    def next(self):
        if not shuffle:
            #print "playing next song in albumlist"
            if CLICKMODE==CLICK_PLAYNOW:
                self.currentPlayIndex=self.currentPlayIndex+1
                if (len(self.currentAlbumFileList)<=self.currentPlayIndex):
                    self.nextAlbum()
                if (len(self.currentAlbumFileList)>0):
                    next = self.currentAlbumFileList[self.currentPlayIndex]
                else:
                    next=None
                if next != None:
                    self.playSong(self.currentPlayIndex)
            elif CLICKMODE==CLICK_QUEUE:
                self.playQueue(0,0)

        else:
            if CLICKMODE==CLICK_PLAYNOW:
                targetAlbum=random.randrange(0, len(artArray)-1, 1)
                self.setAlbum(artArray[targetAlbum].image,albumArtistArray[targetAlbum], albumArray[targetAlbum],targetAlbum)
                self.playAlbum()
                id=0
                if len(self.currentAlbumFileList)>1:
                    id=random.randrange(1, len(self.currentAlbumFileList), 1)-1
                    self.currentPlayIndex=id
                #print "id:" + str(id)
                next = self.currentAlbumFileList[id]
                if next != None:
                    self.playSong(self.currentPlayIndex)
            elif CLICKMODE==CLICK_QUEUE:
                id=0
                if len(self.songQueue)>1:
                    id=random.randrange(0, len(self.songQueue)-1, 1)-1
                    self.playQueue(0, id)
                else:
                    if len(self.songQueue)==0:
                        self.stop()
                    else:
                        self.playQueue(0, 0)


    def play(self):
        print "starting playback"
        self.playOn=1
        if NOT_MAC:
            self.player.set_state(gst.STATE_PLAYING)
        else:
            pygame.mixer.music.play()
        playAlbumButton.setPause()

    def pause(self):
        print "Real Pause action performed"
        global playAlbumButton
        self.playOn=0
        if NOT_MAC:
            self.player.set_state(gst.STATE_PAUSED)
        else:
            pygame.mixer.music.pause()
        playAlbumButton.setPlay()

    def stop(self):
        print "STOP"
        if NOT_MAC:
            if (self.player != None): self.player.set_state(gst.STATE_NULL)
        else:
            pygame.mixer.music.stop()

    def showNextAlbum(self):
        self.currentPlayIndex=0
        #If in normal mode, move to next album or first album
        targetAlbum=0
        if (self.albumId<len(albumArtistArray)-1):
            targetAlbum=self.albumId+1
        self.setAlbum(artArray[targetAlbum].image,albumArtistArray[targetAlbum], albumArray[targetAlbum],targetAlbum)
        #self.playAlbum()

    def nextAlbum(self):
        global nowPlayingAlbum
        self.currentPlayIndex=0
        #If in normal mode, move to next album or first album
        targetAlbum=0
        if (nowPlayingAlbum<len(albumArtistArray)-1):
            targetAlbum=nowPlayingAlbum+1
        nowPlayingAlbum=targetAlbum
        self.setAlbum(artArray[targetAlbum].image,albumArtistArray[targetAlbum], albumArray[targetAlbum],targetAlbum)
        #self.playAlbum()

    def previousAlbum(self):
        global nowPlayingAlbum
        targetAlbum=len(albumArtistArray)-2
        if (nowPlayingAlbum>1):
            targetAlbum=nowPlayingAlbum-1
        nowPlayingAlbum=targetAlbum
        self.setAlbum(artArray[targetAlbum].image,albumArtistArray[targetAlbum], albumArray[targetAlbum],targetAlbum)
        #self.playAlbum()
        self.currentPlayIndex=len(self.currentAlbumFileList)-1

    def showPreviousAlbum(self):
        targetAlbum=len(albumArtistArray)-2
        if (self.albumId>1):
            targetAlbum=self.albumId-1
        self.setAlbum(artArray[targetAlbum].image,albumArtistArray[targetAlbum], albumArray[targetAlbum],targetAlbum)
        self.currentPlayIndex=len(self.currentAlbumFileList)-1


    def previous(self):
        if CLICKMODE==CLICK_PLAYNOW:
            self.currentPlayIndex=self.currentPlayIndex-1
            if (self.currentPlayIndex==-1):
                self.previousAlbum()
            if (len(self.currentAlbumFileList)>0):
                next = self.currentAlbumFileList[self.currentPlayIndex]
            else: next=None
            if next != None:
                self.playSong(self.currentPlayIndex)
        elif CLICKMODE==CLICK_QUEUE:
            self.playPreviousQueue()


    def addQueue(self, playIndex):
        filename=self.currentAlbumFileList[playIndex]
        self.songQueue.append(filename)
        if len(self.songQueue)==1:
            self.playQueue(1,0);
        self.updateQueueButton()
        songItems[playIndex].setSelected()
        self.resetSelections()

    def removeQueue(self, playIndex):
        filename=self.currentAlbumFileList[playIndex]
        self.songQueue.remove(filename)
        self.updateQueueButton()
        songItems[playIndex].setSelected()
        self.resetSelections()

    def updateQueueButton(self):
        font = pygame.font.Font(None, 16)
        queuecountButton.image.blit(queuecountButton.altbackground, (0,0))
        test=font.render("QUEUE SIZE:"+str(len(self.songQueue)), 1, MAINFONTCOLOR, MAINFONTBGCOLOR)
        #test.set_colorkey(MAINFONTBGCOLOR)
        queuecountButton.image.blit(test, (30, 25))
        queuecountButton.setVisible()

    def setSongDetailsFromFilename(self, filename):
        global songlist, filelist, albumlist, artArray, songButton
        global nowPlayingSongName, nowPlayingAlbum, nowPlayingAlbumName, nowPlayingArtistName
        i=0
        while i<len(filelist):
            if filelist[i]==filename:
                nowPlayingSongName=songlist[i]
                nowPlayingAlbumName=albumlist[i]
                nowPlayingArtistName=artistlist[i]
                nowPlayingAlbum=0
                j=0
                for art in artArray:
                    if art.album==albumlist[i]:
                        nowPlayingAlbum=j                        
                    j=j+1
                
                #albumImage=artArray[nowPlayingAlbum].image
                #albumImage=pygame.transform.scale(albumImage, (72, 75))
                #albumButton.setImage(albumImage)
                songButton.setSong(nowPlayingSongName,nowPlayingAlbumName, nowPlayingArtistName)
                #font = pygame.font.Font(None, 16)
                #albumButton.setVisible()
                #albumButton.update()
                if self.albumId==nowPlayingAlbum:
                    self.resetSelections()

            i=i+1
    def resetSelections(self):
        j=0
        while j<30:
            if songItems[j].song==nowPlayingSongName:
                songItems[j].setSelected()
            else:
                songItems[j].deselect()
            j=j+1

    def playQueue(self, addMode, indexId):
        qfilename=""
        if len(self.songQueue)>indexId:
            if len(self.songQueue)>1:
                qfilename=self.songQueue.pop(indexId)
                if self.previousFile==qfilename:
                    qfilename=self.songQueue.pop(indexId)
            else:
                if addMode==0:
                    qfilename=self.songQueue.pop(indexId)
                else:
                    qfilename=self.songQueue[indexId]

            self.playFile(qfilename)
            if not self.previousFile=="":
                self.playedList.append(self.previousFile)
            self.previousFile=qfilename
        else:
            self.stop()
        self.updateQueueButton()


    def playPreviousQueue(self):
        #Move previous top song to queue bottom (next to be played)
        if len(self.playedList)>0:
            #push currently playing song to queue
            if not self.previousFile=="":
                self.songQueue.insert(0, self.previousFile)

            #then insert from backlog to queue
            lastSongFile=self.playedList.pop(len(self.playedList)-1)
            self.songQueue.insert(0, lastSongFile)
            self.previousFile=""
            self.playQueue(0,0)
        else:
            self.stop()
        self.updateQueueButton()

    def playSong(self, playIndex):
        global nowPlayingAlbum
        global nowPlayingSongName
        if self.albumId==nowPlayingAlbum:
            i=0
            while i<30:
                songItems[i].deselect()
                i=i+1
        if (playIndex<len(self.currentAlbumFileList)): self.currentPlayIndex=playIndex
        else: self.currentPlayIndex=0
        filename=self.currentAlbumFileList[self.currentPlayIndex]
        self.playFile(filename)
        


    def seekForward(self):
        if NOT_MAC:
            newPosition=self.getPosition()
            if newPosition>0:
                print "seeking from " + str(newPosition)
                newPosition=newPosition+7000000000
                print "seeking to " + str(newPosition)
                self.seek(newPosition)

    def seekBackward(self):
        if NOT_MAC:
            newPosition=self.getPosition()            
            
            newPosition=newPosition-7500000000
            if newPosition>0:
                self.seek(newPosition)
            else:
                self.seek(0)

    #location in milliseconds
    def seek(self, location):

        if self.player.get_state() != gst.STATE_PAUSED:
            self.player.set_state(gst.STATE_PAUSED)

        event = gst.event_new_seek(1.0, gst.FORMAT_TIME,
            gst.SEEK_FLAG_FLUSH | gst.SEEK_FLAG_ACCURATE,
            gst.SEEK_TYPE_SET, location,
            gst.SEEK_TYPE_NONE, 0)

        res = self.player.send_event(event)
        if res:
            print "setting new stream time to 0"
            self.player.set_new_stream_time(0L)
        else:
            print "seek to %r failed" % location
        self.player.set_state(gst.STATE_PLAYING)


    def getVolume(self):
        global volume
        # playbin volume is a double from 0.0 - 10.0
        volume=0.0
        if NOT_MAC:
            volume=self.player.get_property('volume')
        else:
            volume=pygame.mixer.music.get_volume()
        return volume

    def setVolume(self, newVolume):
        global volume
        newVolume = min(8.0, max(newVolume, 0.0))
        #newVolume = int(newVolume)        
        volume=newVolume
        print "new volume"  + str(newVolume)
        if NOT_MAC:            
            self.player.set_property('volume',  newVolume)
        else:
            volume=pygame.mixer.music.set_volume(newVolume/100.0)

    def playFile(self,filename):
        global playAlbumButton
        global changed
        global cdClicked
        global volume
        global lastSongPosition
        
        lastSongPosition=0

        if NOT_MAC:
            self.player.set_state(gst.STATE_NULL)
            fileformat = getFormatFromFileName(filename)
            #if fileformat == FORMAT_AUDIO_OGG:
            #    self.createGSTOGGPlayer()
            #elif fileformat == FORMAT_AUDIO_WMA:
            #    self.createGSTWMAPlayer()
            #elif fileformat == FORMAT_AUDIO_AAC:
            #    self.createGSTAACPlayer()
            #elif fileformat == FORMAT_AUDIO_M4A:
            #    self.createGSTM4APlayer()
            #else:
            #    self.createGSTPlayer()

            #time.sleep(0.10)

            print "Playing file: " + filename
            try:
                #self.source.set_property("location", filename)
                self.player.set_property("uri", "file://"+filename)
                if ISMAEMO == 1:
                    self.setVolume(volume)
                self.player.set_state(gst.STATE_PLAYING)
                self.playOn=1                
                self.playing = True 
            except:
                print "playFile(): CANNOT PLAY MUSIC"
            #self.source.set_property( "location", filename )

        else:
                #self.currentPlayIndex=0
            print "playing file" + filename
            try:
                pygame.mixer.music.stop()
                time.sleep(0.10)
                pygame.mixer.music.load(filename)

                self.play()
                self.playOn=1
            except:
                print "playFile(): problems playing file. File may be corrupt:" +filename
                #self.next()

        self.setSongDetailsFromFilename(filename)
        if ISMAEMO: updateScrobbler()
        playAlbumButton.setPause()
        changed=1
        cdClicked=1

    def playAlbum(self):
        global albumButton
        global artArray
        #TEMP TEST
        global nowPlayingAlbum
        #nowPlayingAlbum=self.albumId
        print "Setting album to be in played list"+str(self.albumId)
        self.currentAlbumFileList=[]
        for song in self.displayedAlbumFileList:
            self.currentAlbumFileList.append(song)


    def update(self):
        i=0



##################################
#### SONGITEM
##################################

class SongItem(pygame.sprite.Sprite):


    def __init__(self, mainbg,positionindex):
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.rect = self.image.get_rect()
        self.mainbg = mainbg
        self.rect.bottom = 440
        self.positionindex=positionindex
        self.albumwidth=ALBUMSPACEWIDTH
        self.posy=SONGLISTSTARTY

        self.selected=0
        self.song=""
        self.songId=-1
        self.songNumber=""


        self.selected=0
        self.font = pygame.font.SysFont(None, 22)
        self.fontNumber = pygame.font.SysFont(None, 28)
        self.mouseOver=0

    def writeSongDetails(self, song, isSelected):
        if isSelected:
            self.image.blit(self.activeImage, (0,0))
        else:
            self.image.blit(self.background, (0,0))
        if len(song)>0:
            songNameArray=song.split(" ")
            if songNameArray[0].isdigit():
                self.songNumber=songNameArray[0]
                song=song.lstrip('01234567890 ')
                test=self.fontNumber.render(self.songNumber, 1, (117,138,159))
                self.image.blit(test, (10,26))
            else:
                self.songNumber=""
        songNameArray=song.split(" ")
        print songNameArray
        lineNumber=0
        linePart=""
        for namePart in songNameArray:
            if len(linePart+namePart)<22:
                linePart=linePart+namePart+" "
            else:
                test=self.font.render(linePart, 1, MAINFONTCOLOR)
                self.image.blit(test, (40,(10+lineNumber*25)))
                linePart=namePart+" "
                lineNumber=lineNumber+1
        if len(linePart)>0:
            test=self.font.render(linePart, 1, MAINFONTCOLOR)
            self.image.blit(test, (40,(10+lineNumber*25)))
            linePart=namePart


    def setSong(self, song, songId):
        global nowPlayingSongId
        global songlister
        global filelist
        self.songId=songId
        self.song=song

        self.writeSongDetails(song, False)
        self.selected=0
        self.mouseOver=0
        if songId==nowPlayingSongId:
            self.setSelected()
        self.showQueueInfo()

    def deselect(self):
        global changed
        global cdClicked
        
        global songlister
        global filelist
        if (self.selected==1):
            self.selected=0
            self.setSong(self.song, self.songId)
            cdClicked=1
            changed=1

        if CLICKMODE==CLICK_QUEUE:
            if songlister.songQueue.count(filelist[self.songId])>0:
                self.setSong(self.song, self.songId)
                #print "Deselected: " + self.song

    def deHover(self):
        global changed
        global cdClicked
        
        self.setSong(self.song, self.songId)
        cdClicked=1
        changed=1
        #print "Deselected: " + self.song

    def showQueueInfo(self):
        if CLICKMODE==CLICK_QUEUE and songlister.songQueue.count(filelist[self.songId])>0:
            songposition=str(songlister.songQueue.index(filelist[self.songId])+1)
            songcountText=self.font.render(songposition, 1, MAINFONTCOLOR)
            self.image.blit(songcountText, (5,4))

    def setSelected(self):
        self.writeSongDetails(self.song, True)
        self.selected=1        
        self.showQueueInfo()

    def deleteSong(self, songId, songPosition):
        if songId>-1:
            global songItems,cdClicked,changed
            fname=filelist.pop(songId)
            alname=albumlist.pop(songId)
            arname=artistlist.pop(songId)
            songname=songlist.pop(songId)

            songItems[songPosition].setSong("Deleted", -1)
            for si in songItems:
                if si.songId>songId:
                    if si.songId>0:
                        si.songId=si.songId-1
            print "Deleted "+ fname
            os.remove(fname)
            cdClicked=1
            changed=1


    def setHover(self):        
        self.writeSongDetails(self.song, True)
        self.mouseOver=2
        self.showQueueInfo()

    def update(self):
        global playSelected, mouseMoved
        if viewMode==ALBUMCONTENTVIEW or viewModeToBe==ALBUMCONTENTVIEW:
            if mouseMoved<0 or currentAlbumSongCount<10:
                mouseMoved=0
            elif mouseMoved>(currentAlbumSongCount-10)*105:
                mouseMoved=(currentAlbumSongCount-10)*105
            
            self.posx=(self.positionindex/3)*238-mouseMoved
            self.posy=SONGLISTSTARTY-164            
            if (self.positionindex+1)%3==0:            
                self.posy=SONGLISTSTARTY
            elif (self.positionindex+2)%3==0:            
                self.posy=SONGLISTSTARTY-82

            self.rect.left = self.posx
            self.rect.bottom = self.posy

        if(viewModeToBe!=ALBUMCONTENTVIEW): visible.remove(self)
        if viewMode==ALBUMCONTENTVIEW:
            #if (viewMode==ALBUMCONTENTVIEW and self.rect.collidepoint(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1])):
                #Mouse over
                #if self.mouseOver==0:
                #    self.setHover()
                #else:
                #    self.mouseOver=2
            if ( buttonPressed==1 and self.rect.collidepoint(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1])):
                if (len(songlister.displayedAlbumFileList)>self.positionindex):
                    if not playSelected:
                        if CLICKMODE==CLICK_PLAYNOW:
                            songlister.playAlbum()
                            songlister.playSong(self.positionindex)
                            playSelected=True
                            #setCurrentPlayMode()
                        if CLICKMODE==CLICK_DELETE:
                            self.deleteSong(self.songId, self.positionindex)
                        if CLICKMODE==CLICK_QUEUE:
                            if songlister.songQueue.count(filelist[self.songId])>0:
                                songlister.playAlbum()
                                songlister.removeQueue(self.positionindex)
                                playSelected=True
                            else:
                                songlister.playAlbum()
                                songlister.addQueue(self.positionindex)
                                playSelected=True

            #if self.mouseOver>0:
            #    self.mouseOver=self.mouseOver-1
            #    if self.mouseOver==0:
            #        self.deHover()

##################### #####################
##################### CONTROL BUTTON
##################### #####################

class ControlButton(pygame.sprite.Sprite):
    def __init__(self,x,y,buttonType):
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.rect = self.image.get_rect()
        self.rect.top = y
        self.rect.left = x
        self.posy=y
        self.posx=x
        self.buttonType=buttonType
        self.buttonHandled=False
        self.isVisible=False
        self.nameNotDrawn=True
        
    def setVisible(self):
        global visible
        self.isVisible=True
        visible.add(self)

    def setInvisible(self):
        global visible
        self.isVisible=False
        visible.remove(self)

    def setPause(self):
        global pauseAlbumImage
        self.image=pauseAlbumImage
        self.buttonType="PAUSE"
        self.isVisible=True
        self.newDraw()

    def setImage(self, image):
        self.image=image
        self.rect = self.image.get_rect()
        self.rect.left = self.posx
        self.rect.bottom = self.posy
    
    def setProgress(self, currentPosition):
        global nowPlayingAlbumName, nowPlayingSongName, mouseMoved
        
        if self.isVisible and mouseMoved==0:
            self.image.set_clip()
            self.image.blit(self.background, (0,0))
            self.image.set_clip((0,0,currentPosition*3+24,27))
            self.image.blit(self.activeBackground, (0,0))
            
            self.image.set_clip()
            font = pygame.font.Font(None,16)
            test=font.render( songlister.getSongLengthString(), 1, ALTFONTCOLOR)
            #test.set_colorkey(MAINFONTBGCOLOR)
            self.image.blit(test, (260, 4))
            
            test=font.render( songlister.getSongPositionString(), 1, ALTFONTCOLOR)
            test.set_colorkey(MAINFONTBGCOLOR)
            self.image.blit(test, (15, 4))
            
            
            #test=font.render( nowPlayingSongName, 1, ALTFONTCOLOR)
            #test.set_colorkey(MAINFONTBGCOLOR)
            #self.image.blit(test, (110, 4))

            self.newDraw()
            pygame.display.flip()
            #print "progress set to" + str(currentPosition)
        
    
    def setPlay(self):
        global playAlbumImage
        self.image=playAlbumImage
        self.buttonType="PLAY"
        self.isVisible=True
        self.newDraw()

    def setButtonType(self, buttonType):
        self.buttonType=buttonType

    def onClick():
        print "clicked on:" +self.buttonType

    def setButton(self,x,y,buttonType):
        self.posx=x
        self.posy=y
        self.rect.bottom = y
        self.rect.left = x
        self.buttonType=buttonType

    def setRect(self, newrect):
        self.rect=newrect


    def playPressed(self):
        #print "Play button pressed"
        songlister.play()

    def pausedPressed(self):
        #print "pause button pressed"
        songlister.pause()

    def newDraw(self):
        if (self.isVisible): screen.blit(self.image,(self.rect.left, self.rect.top))


    def setQueueMode(self):
        global CLICKMODE, CLICK_PLAYNOW, CLICK_QUEUE,songlister, shuffleClicked
        CLICKMODE=CLICK_QUEUE
        self.image.blit(queuecountButton.altbackground, (0,0))
        self.buttonType="DELETE"
        songlister.updateQueueButton()
        shuffleClicked=1

    def setContinuousMode(self):
        global CLICKMODE, CLICK_PLAYNOW, CLICK_QUEUE,songlister, shuffleClicked
        CLICKMODE=CLICK_PLAYNOW
        self.image.blit(queuecountButton.background, (0,0))
        font = pygame.font.Font(None,16)
        test=font.render("CONTINUOUS PLAY", 1, MAINFONTCOLOR)        
        self.image.blit(test, (10, 25))
        self.buttonType="QUEUE"
        if viewMode==VIDEOLISTVIEW:
            self.buttonType="DELETE"
        shuffleClicked=1


    def setMovieMode(self):        
        setVideoListView()
        
    def setMusicMode(self):
        setAlbumListView()
        global viewMode, ALBUMLISTVIEW, viewModeToBe
        print "setting music mode1"
        if not viewMode==ALBUMLISTVIEW:
            print "setting music mode2"
            #Change mode to videoList
            viewMode=ALBUMLISTVIEW
            viewModeToBe=ALBUMLISTVIEW
            updateCovers()
            pygame.display.flip()

    def setDeleteMode(self):
        global CLICKMODE, CLICK_PLAYNOW, CLICK_QUEUE,songlister, shuffleClicked
        CLICKMODE=CLICK_DELETE
        self.image.blit(queuecountButton.background, (0,0))
        font = pygame.font.Font(None,16)
        test=font.render("DELETE ON CLICK", 1, (240,0,0))        
        self.image.blit(test, (20, 25))
        self.buttonType="CONTINUOUS"
        shuffleClicked=1

    def setSong(self,songName, albumName, artistName):    
        self.image.blit(self.background, (0,0))
        font = pygame.font.Font(None,30)
        test=font.render(songName, 1, MAINFONTCOLOR)        
        self.image.blit(test, (3, 15))
        font = pygame.font.Font(None,20)
        test=font.render(artistName+ " - " +albumName, 1, MAINFONTCOLOR)        
        self.image.blit(test, (3, 0))
        #print "setting top song"
                
    def update(self):
        global viewMode
        global changed
        global noshuffleImage
        global shuffleImage
        global shuffle
        global shuffleClicked
        
        if self.buttonType=="PROGRESS":
            self.nameNotDrawn=True
        #self.rect.left = self.posx
        #self.rect.bottom = self.posy
        if (not self.buttonHandled and buttonPressed==1 and self.rect.collidepoint(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1])):
            self.buttonHandled=True
            changed=1
            if self.buttonType=="LIST":                
                setAlbumListView()                    
            elif self.buttonType=="ALBUM":
                if viewMode==ALBUMLISTVIEW:
                    print "BUHUU!"
                    setAlbumContentView()
            elif (self.buttonType=="PAUSE"):
                self.pausedPressed()
            elif self.buttonType=="PLAY":
                self.playPressed()
            elif self.buttonType=="NEXT":
                songlister.next()
            elif self.buttonType=="PREVIOUS":
                songlister.previous()
            elif self.buttonType=="QUEUE":
                self.setQueueMode()
            elif self.buttonType=="DELETE":
                self.setDeleteMode()
            elif self.buttonType=="CONTINUOUS":
                self.setContinuousMode()
            elif self.buttonType=="MUSIC":
                self.setMusicMode()
            elif self.buttonType=="MOVIE":
                self.setMovieMode()
            elif self.buttonType=="EXIT":
                print "EXITING..."
                sys.exit()
                
            elif self.buttonType=="PROGRESS":
                print "clicked on: " + str(pygame.mouse.get_pos()[0]-self.rect.left)
                if viewMode==ALBUMCONTENTVIEW and not cdClicked:
                    newpercent=(pygame.mouse.get_pos()[0]-self.rect.left)/3 
                    newpercent=newpercent-6
                    songlister.setPercentPosition(newpercent)
                
            elif self.buttonType=="SHUFFLE":
                shuffleClicked=1
                if shuffle:
                    shuffle=False
                    self.image=noshuffleImage
                else:
                    shuffle=True
                    self.image=shuffleImage
        else:
            self.buttonHandled=False


class CoverArt(pygame.sprite.Sprite):

    def __init__(self, mainbg,positionindex):
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.rect = self.image.get_rect()
        self.mainbg = mainbg
        self.rect.bottom = 480
        self.positionindex=positionindex
        self.albumwidth=ALBUMSPACEWIDTH
        self.posx=positionindex*self.albumwidth
        self.currentposition=positionindex
        self.lastSelectedCD=selectedCD
        self.selected=0
        self.albumId=0
        self.isVisible=True
        self.font = pygame.font.Font(None,22)

    def setAlbum(self, givenimage, artist, album,albumId, imageType,filename):
        self.album=album
        self.artist=artist

        if imageType==0:
            if not givenimage.get_width()==160:
                givenimage=pygame.transform.scale(givenimage, (160, 160))
            self.image.blit(givenimage, (0,0))

            #Reflection
            #givenimage=pygame.transform.flip(givenimage, 0, 1)
            #givenimage.set_alpha(60)
            #self.image.blit(givenimage, (0,160))

            #artist name in the reflection space
            test=self.font.render(self.artist, 1, MAINFONTCOLOR)
            self.image.blit(test, (5, 165 )) 

            #print "album creation time: " + str(time.time()-aics)
            #Save cache version
            if IMAGECACHINUSE:
                try:
                    pygame.image.save(self.image,filename+".cache.tga")
                    print "saving cache:" +filename+".cache.tga"
                except:
                    print "setAlbum(): save not successfull for cache for "+filename
        else:
            self.image.blit(givenimage, (0,0))

        self.albumId=albumId
        #songcount=self.countSongs(self.album)
        #test=self.font.render(str(songcount), 1, MAINFONTCOLOR)
        #self.image.blit(test, (110, 4))

        self.image.set_colorkey(None)


    def countSongs(self, album):
        global songlist
        global albumlist
        j=0
        i=0
        for song in songlist:
            if (albumlist[i]==album):
                j=j+1
            i=i+1
        return j



    def setSelected(self):
        global activeCD
        self.selected=1
        activeCD=self.albumId
        #print "set selected"
        visible.add(self)

    def deselect(self):
        self.selected=0
        visible.remove(self)

    def setunknown(self):
        if len(self.album)>0:
            font = pygame.font.Font(None, 17)
            test=font.render(self.album, 1, MAINFONTCOLOR)
            self.image.blit(test, (2, 145))

    def newDraw(self):
        if (self.isVisible): screen.blit(self.image,(self.rect.left, self.rect.top))

    def moveOut(self, step):
        if (self.isVisible):
            newX=0
            newY=0
            if self.rect.top>240:
                newY=self.rect.top+40*step
            else:
                newY=self.rect.top-70*step
            screen.blit(self.image,(self.rect.left, newY))

    def halfDraw(self):
        if (self.isVisible): screen.blit(self.image,(self.rect.left, self.rect.top+80))

    def update(self):
        global selectedCD
        global activeCD
        global cdClicked
        global buttonPressed
        global viewMode
        global viewModeToBe
        global selectedArtArrayId
        global mouseReleased,lastMouseReleased


        if (viewMode==ALBUMLISTVIEW or viewModeToBe==ALBUMLISTVIEW):
            bottom=440
            centerx=0
            
            #if SMOOTHSCROLLENABLED: bottom = 640
            if (self.currentposition==0): self.currentposition=-1
            while (self.lastSelectedCD>selectedCD):
                self.currentposition=self.currentposition-1
                self.lastSelectedCD=self.lastSelectedCD-1
                if (self.currentposition==0): self.currentposition=len(artArray)
            while (self.lastSelectedCD<selectedCD):
                self.currentposition=self.currentposition+1
                self.lastSelectedCD=self.lastSelectedCD+1
                if (self.currentposition==len(artArray)+1): self.currentposition=1

            #Easen up the processing if large number of cds.
            #if (self.currentposition>21): return

            if self.currentposition<16:
                
                if (self.currentposition%2==0):                    
                    centerx=(self.currentposition/2)*self.albumwidth
                    bottom = bottom-ALBUMHEIGHT
                else:                    
                    centerx=(self.currentposition/2)*self.albumwidth
                if SMOOTHSCROLLENABLED: centerx=centerx-speedModifier*mouseMoved

            if self.currentposition<16 and (viewMode==ALBUMLISTVIEW or viewModeToBe==ALBUMLISTVIEW):
                if (self.currentposition<16):
                    visible.add(self)
                    self.isVisible=True

            if (self.currentposition>15 and (viewMode==ALBUMLISTVIEW or viewModeToBe==ALBUMLISTVIEW)):
                visible.remove(self)
                self.isVisible=False
                
            self.rect.bottom=bottom
            if len(artArray)>9:
                self.rect.right=centerx-self.albumwidth
            else:
                self.rect.right=centerx+self.albumwidth
            
            if (buttonPressed==1 and viewMode==ALBUMLISTVIEW): visible.remove(self)
            if (cdClicked==0 and viewMode==ALBUMLISTVIEW and buttonPressed==1 and self.rect.collidepoint(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1])):
                print "click difference:" + str(mouseReleased- lastMouseReleased)
                if (mouseReleased- lastMouseReleased)>0.2:
                    songlister.setAlbum(self.image,self.artist,self.album, self.albumId)
                    visible.add(songlister)
                    self.setSelected()
                    cdClicked=1
                    viewModeToBe=ALBUMCONTENTVIEW
                    explodeAlbums()
            if ((viewMode==ALBUMCONTENTVIEW and viewModeToBe==ALBUMCONTENTVIEW) or (viewModeToBe==ALBUMCONTENTVIEW)):
                if (self.albumId==activeCD):
                #nowPlayingAlbum#activeCD
                    self.rect.left = ALBUMCOVERSTARTX
                    self.rect.bottom = ALBUMCOVERSTARTY-2
                    visible.add(self)
                    selectedArtArrayId=self.positionindex
                    #print "selected " + self.album
                else:
                    visible.remove(self)

            self.lastSelectedCD=selectedCD
        else:
            if self.albumId==activeCD and (viewModeToBe==ALBUMCONTENTVIEW):
                self.rect.left = ALBUMCOVERSTARTX
                self.rect.bottom = ALBUMCOVERSTARTY-2
                visible.add(self)
                selectedArtArrayId=self.positionindex
            else:
                visible.remove(self)



class VideoClip(pygame.sprite.Sprite):

    def __init__(self, mainbg,positionindex):
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.rect = self.image.get_rect()
        self.mainbg = mainbg
        self.rect.bottom = 480
        self.positionindex=positionindex
        self.albumwidth=ALBUMSPACEWIDTH
        self.posx=positionindex*self.albumwidth
        self.currentposition=positionindex
        self.lastSelectedClip=selectedCD
        self.selected=0
        self.clipId=0
        self.isVisible=True
        self.font = pygame.font.Font(None,18)
        self.clipname=""
        self.filename=""

    def makeImageOSX(self, filename, clipname):
        command="./mplayer -ss 30 -nosound -vo tga -frames 1 \""+filename+"\""
        startpos=str(random.randint(30,80))
        command="./mplayer -zoom -ss "+startpos+" -nosound -vo tga -frames 2 -vf scale=160:-3  \""+filename+"\""
        print command
        os.system(command)
        command="cp 00000002.tga \""+coverlocation+clipname+".tga\""
        print command
        os.system(command)
        command="rm 00000002.tga "
        os.system(command)
        command="rm 00000001.tga "
        os.system(command)

    def makeImageLinux(self, filename, clipname):
        startpos=str(random.randint(30,80))
        command="mplayer -zoom -ss "+startpos+" -nosound -vo jpeg:outdir=\""+coverlocation+"\" -frames 2 -vf scale=160:-3  \""+filename+"\""
        #print command
        os.system(command)
        command="cp \""+coverlocation+"00000002.jpg\" \""+coverlocation+clipname+".jpg\""        
        os.system(command)

    def setClip(self, givenimage, clipname, clipId, imageType,filename):
        self.clipname=clipname
        self.clipId=clipId
        self.filename=filename
        clipcover=""
        if ISMAEMO:
            clipcover=coverlocation+clipname+".jpg"
        else:
            clipcover=coverlocation+clipname+".tga"
        if not (os.path.exists(clipcover)):
            if ISMAEMO:
                self.makeImageLinux(filename, clipname)
                showInfo("Creating video thumbnail")
                #print "images disabled for maemo"
            else:
                self.makeImageOSX(filename, clipname)
                showInfo("Creating video thumbnail")

            #If creation successful, then use that instead
        if (os.path.exists(clipcover)):
            givenimage=load_image(clipcover)
        if imageType==0:
            if not givenimage.get_width()==VIDEOCOVERWIDTH:
                if givenimage.get_width()==160 or self.filename.find(".flv")>0:
                    if givenimage.get_width()==160 and givenimage.get_height()<100:
                        givenimage=pygame.transform.scale(givenimage, (VIDEOCOVERWIDTH, 96))
                        self.image.blit(givenimage, (0,60))
                    else:
                        givenimage=pygame.transform.scale(givenimage, (VIDEOCOVERWIDTH, 116))
                        self.image.blit(givenimage, (0,60))                    
                else:
                    givenimage=pygame.transform.scale(givenimage, (VIDEOCOVERWIDTH, 128))
                    self.image.blit(givenimage, (0,60))
            #Reflection
            #givenimage=pygame.transform.flip(givenimage, 0, 1)
            #givenimage.set_alpha(60)
            #self.image.blit(givenimage, (0,125))

            #artist name in the reflection space
            fclipname=self.clipname+" "
            fclipname=string.replace(fclipname,"video","")
            fclipname=string.replace(fclipname,"Video","")
            fclipname=string.replace(fclipname,".nokia770.avi","")
            fclipname=string.replace(fclipname,".avi","")
            fclipname=string.replace(fclipname,".mov","")
            fclipname=string.replace(fclipname,".mp4","")
            fclipname=string.replace(fclipname,".flv","")
            fclipname=string.replace(fclipname,"."," ")
            fclipname=string.replace(fclipname,"_"," ")
            test=self.font.render(fclipname, 1, MAINFONTCOLOR)
            self.image.blit(test, (5, 165))
            showInfo("ADDING VIDEO: "+fclipname, self.image)
            
        else:
            self.image.blit(givenimage, (0,0))

        self.image.set_colorkey(None)


    def newDraw(self):
        if (self.isVisible): screen.blit(self.image,(self.rect.left, self.rect.top))

    def moveOut(self, step):
        if (self.isVisible):
            newX=0
            newY=0
            if self.rect.top>240:
                newY=self.rect.top+40*step
            else:
                newY=self.rect.top-70*step
            screen.blit(self.image,(self.rect.left, newY))

    def halfDraw(self):
        if (self.isVisible): screen.blit(self.image,(self.rect.left, self.rect.top+80))

    def update(self):
        global cdClicked
        global buttonPressed
        global viewMode, clipList
        global viewModeToBe
        global mouseReleased,lastMouseReleased



        if viewMode==VIDEOLISTVIEW and viewModeToBe==VIDEOLISTVIEW:
            
            
            bottom=440
            centerx=0
    
            if (self.currentposition==0): self.currentposition=-1

            while (self.lastSelectedClip>selectedCD):
                self.currentposition=self.currentposition-1
                self.lastSelectedClip=self.lastSelectedClip-1
                if (self.currentposition==0): self.currentposition=len(clipList)
            while (self.lastSelectedClip<selectedCD):
                self.currentposition=self.currentposition+1
                self.lastSelectedClip=self.lastSelectedClip+1
                if (self.currentposition==len(clipList)+1): self.currentposition=1

            if self.currentposition<16:
                visible.add(self)
                self.isVisible=True                
                if (self.currentposition%2==0):                    
                    centerx=(self.currentposition/2)*self.albumwidth
                    bottom = bottom-ALBUMHEIGHT
                else:                    
                    centerx=(self.currentposition/2)*self.albumwidth
                if VIDEOSMOOTHSCROLLENABLED: centerx=centerx-speedModifier*mouseMoved


            if (self.currentposition>15 and (viewMode==ALBUMLISTVIEW or viewModeToBe==ALBUMLISTVIEW)):
                visible.remove(self)
                self.isVisible=False
            
            
            
            self.rect.bottom=bottom
            if len(clipArray)>9:
                self.rect.right=centerx-self.albumwidth
            else:
                self.rect.right=centerx+self.albumwidth
            

            if (buttonPressed==1 and viewMode==VIDEOLISTVIEW): visible.remove(self)
            if (cdClicked==0 and viewMode==VIDEOLISTVIEW and buttonPressed==1 and self.rect.collidepoint(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1])):
                if (mouseReleased-lastMouseReleased)>0.2:
                    if CLICKMODE==CLICK_DELETE:
                        print "SHOULD DELETE!!"
                    else:
                        clearScreen()
                        font = pygame.font.Font(None,30)
                        test=font.render("Starting playback... Press Back button to stop playing", 1, MAINFONTCOLOR, MAINFONTBGCOLOR)
                        test.set_colorkey(MAINFONTBGCOLOR)
                        screen.blit(test,(100, 200))
                        songlister.stop()
                        pygame.display.flip()
                        time.sleep(1.5)
                        clearScreen()
                        pygame.display.flip()
                        for event in pygame.event.get():
                            print "event:"
                        if NOT_MAC:
                            command = 'mplayer -ao esd -vo sdl '
                            #Temp decision to fullscreen all flash videos
                            
                            if self.filename.find(".flv")>0:
                                command = command+"-vf crop=320:192 -correct-pts "
                        else:
                            command = './mplayer  '

                        #Add playlist. Random if needed
                        fileFound=False
                        if shuffle:
                            fileFound=True
                            command=command+ " -shuffle "

                        for clipItem in clipArray:
                            if clipItem.filename==self.filename:
                                fileFound=True
                            if fileFound:
                                if clipItem.filename.find(" ")>0:
                                    command=command+ " \"" + clipItem.filename+"\""
                                else:
                                    command=command+ " " + clipItem.filename
                                fileFound=False
                                #The above to set to play just one file. Remove for continuous play
                        #print command
                        os.system(command)
                        
                        for clipItem in clipArray:
                            clipItem.newDraw()
            self.lastSelectedClip=selectedCD
        else:
            visible.remove(self)
            self.isVisible=False


class SongProcessor:
    def getOSDir(self,addpath, filelist, depth=0):
        try:
            test=os.path.exists(addpath)
            depth=depth+1
            if (test and depth<6):
                for fileName in os.listdir (addpath):
                    try:
                        mediatype = getMediaTypeFromFileName(fileName)
                        if mediatype == MEDIA_TYPE_VIDEO:
                            clipList.append(addpath+"/"+fileName)
                        elif mediatype == MEDIA_TYPE_AUDIO:
                            filelist.append(addpath+"/"+fileName)
                            
                        elif os.path.isdir(addpath+"/"+fileName) and not (fileName.find('.')==0) and not (fileName.find("debian")==0) and not (fileName.find('Maps')==0) and not (fileName.find('maps')==0):
                            self.getOSDir(addpath+"/"+fileName,filelist, depth)
                    except OSError, message:
                        print "getOSDir():OSError:", message
        except OSError, message:
            print "getOSDir():OSError:", message


    def getMusicFiles(self):
        index=0
        mediaDirs = ["/media/mmc1", "/media/mmc2", "/media/mmc3", "/home/user/MyDocs/.sounds"]
        mediaDirs.append("/Volumes/OSX/iTunes") # for testing
        mediaDirs.append("/Users/urhokonttori/Movies") # for testing
        #mediaDirs.append("test") # for testing
        for dir in mediaDirs:
            if (os.path.exists(dir)): 
                self.getOSDir(dir, filelist)
            
    def saveTagList(self):
        i=0
        saveArray=[]
        for fileName in filelist:
            if len(songlist) > i:
                try:
                    #0  #
                    saveString=fileName
                    saveString=saveString+"##==##"
                    saveString=saveString+songlist[i]
                    saveString=saveString+"##==##"+artistlist[i]
                    saveString=saveString+"##==##"+albumlist[i]
                    saveArray.append(str(saveString))
                    
                except UnicodeDecodeError, message:
                    print "saveTagList(): UnicodeDecodeError:", message
            i=i+1
        f = open(coverlocation+"songlist.txt", 'w' )
        f.write( os.linesep.join(saveArray))

    def getCacheFileIndex(self,filecache, fileName):
        i=0
        for cachestring in filecache:
            if cachestring.startswith(fileName):
                return i
            i=i+1
        return -1

    def appendSong(self, trackstr, album, artist, song, fileName):
        slashPos = trackstr.find("/")
        
        # 1/N format?
        if slashPos > -1:
            trackstr = trackstr[0:slashPos]
        
        # single digit format?
        if len(trackstr)==1 and trackstr!=" ":
             song="0"+trackstr+" "+song
            
        # we want two digits
        if len(trackstr)==2:
            song=trackstr+" "+song

        album=str(album)
        if string.find(album, "[u'")==0:
            album=self.fixOddUnicode(album)
        if string.find(song, "[u'")==0:
            song=self.fixOddUnicode(song)
        if string.find(artist, "[u'")==0:
            artist=self.fixOddUnicode(artist)

        try:
            album=unicode(album,'utf8').encode('utf8', 'ignore')
        except:
            album=unicode(album,'latin-1').encode('ascii', 'ignore')

        #print "appending: " + album +"  - " + song

        if album=="":
            album="UNKNOWN"

        if (not album in albumArray):
            albumArray.append(album)
            albumArtistArray.append(artist)
            self.getAlbumCoverFromFile(fileName, album)

        albumlist.append(album)
        artistlist.append(artist)
        songlist.append(song)

    def getMetadataFromFilename(self, fileName ):
        """Tries to parse the song information from the filename. Expects the directory structure to be like iTunes: artist/album/song.xxx. Returns the results as tuple: artist, album, song"""
        fileName=string.replace(fileName,"/media","")
        fileName=string.replace(fileName,"/mmc","")
        if fileName.find(".", ) > -1:
            fileName = fileName[:(fileName.rfind("."))]
        songpath=fileName.split("/")
        artist="UNKNOWN"
        album="UNKNOWN"
        song = None

        if len(songpath)==1:
            song = songpath;
        elif len(songpath)==2:
            song  = songpath[len(songpath)-1]
            album = songpath[len(songpath)-2]
        elif len(songpath)>2:
            song   = songpath[len(songpath)-1]
            album  = songpath[len(songpath)-2]
            artist = songpath[len(songpath)-3]
        return (artist, album, song)




    def getIDTags(self):
        index=0
        filecache=[]
        try:
            f = open(coverlocation+"songlist.txt", 'r' )
            filecache = [i.strip() for i in f.readlines( )]
            f.close()
        except:
            print "getIDTags(): cache file missing, will be generated"

        
        
        checkArray=[]
        for fileName in filelist:
            checkArray.append(fileName)

        #After all music files are in the list, process the files
        for fileName in checkArray:
            song=None
            album=None
            artist=None
            addToList=False
            songDir=""
            trackstr=""
            
            fileFormat = getFormatFromFileName( fileName )
            if fileFormat == FORMAT_AUDIO_MP3 or fileFormat == FORMAT_AUDIO_M4A:
                
                # Only known formats are cached and read from the cache
                cacheIndex=self.getCacheFileIndex(filecache, fileName)
                if cacheIndex>-1:
                    
                    fileEntry=filecache.pop(cacheIndex).split("##==##")
                    if len(fileEntry)>1:
                        song=fileEntry[1]
                        artist=fileEntry[2]
                        album=fileEntry[3]
                        addToList=True
                        self.appendSong(" ", album, artist, song, fileName)
                        continue

            if fileFormat == FORMAT_AUDIO_MP3:
                song=None
                album=None
                artist=None
                addToList=False
                
                if False:
                    #print "Trying ID3"
                    
                    try:
                        infoObj = ID3(fileName)
                        infoObj = infoObj.as_dict()
                        if infoObj.has_key("ALBUM"):  album  = infoObj["ALBUM"]
                        if infoObj.has_key("ARTIST"): artist = infoObj["ARTIST"]
                        if infoObj.has_key("TITLE"):  song   = infoObj["TITLE"]
                        addToList=True
                        if infoObj.has_key("TRACKNUMBER"):
                            trackstr = str(infoObj["TRACKNUMBER"])
                    except InvalidTagError, message:
                        print "getIDTags(): Invalid ID3 tag:", message
                        album=None
                        artist=None
                        song=None
                        addToList=False
                        trackstr=""
                        
                    except IOError, message:
                        print "getIDTags(): IOERROR:", message
                        album=None
                        artist=None
                        song=None
                        addToList=False
                        trackstr=""

                # Finally try the id3 reader
                if album is None or artist is None or song is None or (len(album)>24 or album == "UNKNOWN" or artist.find("?")>-1 or album.find("?")>-1):
                    try:
                        id3r = id3reader.Reader(fileName)
                        if id3r.getValue('album'):      album  = id3r.getValue('album')
                        if id3r.getValue('title'):      song   = id3r.getValue('title')
                        if id3r.getValue('performer'):  artist = id3r.getValue('performer')
                        if id3r.getValue('track'):
                            trackstr=str(id3r.getValue('track'))
                        if id3r.getValue('TPA'):
                            test=id3r.getValue('TPA')
                            if not test=="1/1" and not test=="None":
                                test=string.replace(test,"/2","")
                                test=string.replace(test,"/3","")
                                album=album+"("+test+")"
                        addToList=True
                        #if track=="1" or track==1: id3r.dump()
                    except IOError, message:
                        print "ID TAG ERROR: getIDTags(): IOERROR:", message
                        #MARKING FOR DO NOT ADD. IS NOT MP3 FILE
                        addToList=False
                        album=None
                        artist=None
                        song=None
                        trackstr=""
                        
                if addToList:                        
                    if artist is None or album is None or song is None:
                        # Just in case this is MP3 file with no embedded tags, try to fill in the blanks using the filesystem
                        artistFromFile, albumFromFile, songFromFile = self.getMetadataFromFilename(fileName)
                        if artist is None:
                            artist=artistFromFile
                        if album is None:
                            album=albumFromFile
                        if song is None:
                            song=songFromFile
                        if trackstr is None:
                            trackstr="00"
                            
                    if album==None or len(album)<2: album="unknown"
                    if artist==None or len(artist)<2: artist="unknown"
                    if song==None or len(song)<2: song="unknown"
                    self.appendSong(trackstr, album, artist, song, fileName)
                else:
                    print "Removing (MP3):",fileName,"since we could not identify it sufficiently"
                    filelist.remove(fileName)
                    
                    

            elif fileFormat == FORMAT_AUDIO_M4A:
                global pilImported
                if not pilImported:
                    import PIL
                    pilImported=True
                try:
                    infoObj = PyAtom(fileName)
                    if infoObj.has_key("ALBUM"):  album  = infoObj["ALBUM"]
                    if infoObj.has_key("ARTIST"): artist = infoObj["ARTIST"]
                    if infoObj.has_key("TITLE"):  song   = infoObj["TITLE"]
                    if infoObj.has_key("TRACKNUMBER"):
                        trackstr = str(infoObj["TRACKNUMBER"])
                except IOError, message:
                    # This might be broken M4A file, better remove it
                    print "getIDTags(): IOERROR:", message                    
                    addToList = False
                    artist, album, song = self.getMetadataFromFilename(fileName)
                    addToList = True

                if addToList:
                    if artist is None or album is None or song is None:
                        # Just in case this is M4A file with no embedded tags, try to fill in the blanks using the filesystem
                        artistFromFile, albumFromFile, songFromFile = self.getMetadataFromFilename(fileName)
                        if artist is None:
                            artist=artistFromFile
                        if album is None:
                            album=albumFromFile
                        if song is None:
                            song=songFromFile
                    self.appendSong(trackstr, album, artist, song, fileName)
                else:
                    print "Removing (M4A) ",fileName,"since we could not identify it sufficiently"
                    filelist.remove(fileName)

            elif fileFormat == FORMAT_AUDIO_OGG or fileFormat == FORMAT_AUDIO_WMA or fileFormat ==  FORMAT_AUDIO_AAC:
                #artist, album, song = self.getMetadataFromFilename(fileName)
                
                comments = get_ogg_comments(fileName)    
                song=comments[0]
                artist=comments[1]
                trackstr=comments[2]
                album=comments[3]
                if album=='':
                    print "Using file path for ogg"
                    artist, album, song = self.getMetadataFromFilename(fileName)
                self.appendSong(trackstr, album, artist, song, fileName)
                print "added OGG/WMA/AAC: "+fileName
            else:
                filelist.remove(fileName)
                print "Removing (UNKNOWN FILETYPE) ",fileName,"since we could not identify it sufficiently"



        
        i=0
        #Mark compilations
        for album in albumArray:
            if isCompilation(album):
                albumArtistArray[i]=albumArray[i]
            i=i+1
            
        #quick sort of the albums by artist
        temp=""
        sortArray=[]
        for artist in albumArtistArray:
            sortArray.append(artist)
        sortArray.sort(reverse=True)

        #There is a better way to do this, but for now, this'll have to do. It's really not *THAT* bad.
        i=0
        j=0
        counter=0
        while counter<10:
            i=0
            for sartist in sortArray:
                j=0
                for artist in albumArtistArray:

                    if (artist==sartist):
                        albumArtistArray[j]=albumArtistArray[i]
                        albumArtistArray[i]=sartist

                        temp=albumArray[j]
                        albumArray[j]=albumArray[i]
                        albumArray[i]=temp
                    j=j+1
                i=i+1
            counter=counter+1

        if len (albumArtistArray)<21 and len(albumArtistArray)>10:
            i=0
            end=len(albumArtistArray)
            while i<end:
                albumArray.append(albumArray[i])
                albumArtistArray.append(albumArtistArray[i])
                i=i+1
        self.saveTagList()

    

    
    def getAlbumCoverFromFile(self,fileName, album):
        #print "Trying to get album cover jpg or png " + album
        songpath=fileName.split("/")
        songDir=""+fileName

        thumbFile=getCoverArtThumbFileName(album)
        #fullCoverFileName=getCoverArtFileName(album)
        if len(thumbFile)>1 and os.path.exists(thumbFile): #and os.path.exists(fullCoverFileName):
            # Already have album cover in cache
            return

        if len(songpath)>2:
            song=songpath[len(songpath)-1]
            songDir=songDir.replace(song,"")
            if (os.path.exists(songDir+"cover.jpg")):
                shutil.copyfile(songDir+"cover.jpg",thumbFile)
            else:
                # Check if the song file has embedded album art
                fileFormat = getFormatFromFileName( fileName )
                if fileFormat == FORMAT_AUDIO_MP3:
                    print "MP3 album art functionality not yet done..."
                elif fileFormat == FORMAT_AUDIO_M4A:
                    showInfo("Album art from M4A file (slow) "+fileName)
                    image = PyAtom_getAlbumArt(fileName)
                    if not image is None:
                        #Uncomment to save full sized artwork
                        #image.save( fullCoverFileName, "JPEG" )

                        image = image.resize( THUMBNAIL_SIZE, Image.ANTIALIAS )
                        thumbFile=getCoverArtThumbFileName(album)
                        image.save( thumbFile, "JPEG" )


    def fixOddUnicode(self, paramStr):
        paramStr=string.replace(paramStr,"'-_u'","")
        paramStr=string.replace(paramStr,"', u'","")
        paramStr=string.replace(paramStr,"[u'\u02d9\u0163","")
        paramStr=string.replace(paramStr,"']","")
        return paramStr


    def getAlbumCover(self, i):
        global coverlocation,socketOk
        f=" "
        thumbFile=getCoverArtThumbFileName(albumArray[i])
        #fullCoverFileName=getCoverArtFileName(album)
        found=False
        try:
            f=open(thumbFile,'r')
        except:
            ok=False

        searchString='"'+albumArray[i]+'"'
        searchAltString=albumArray[i]
        compilation=isCompilation(albumArray[i])

        if not compilation:
            searchString=searchString+ ' '+ albumArtistArray[i]
            searchAltString=searchAltString+ ' OR '+ albumArtistArray[i]

        if (f==' ' or f==None) and socketOk:
            found=self.retrieveImageFromNetMSN(searchString + " (cd or cover)",thumbFile)
            if (not(found)):
                print "not found"+thumbFile
                found=self.retrieveImageFromNetMSN(str.replace(searchAltString," ", " OR ") ,thumbFile)
                if (not(found)):                    
                    found=self.retrieveImageFromNet(string.replace(albumArtistArray[i]+" "+ albumArray[i]," "," OR ")+ " OR cd",thumbFile)
                    print found

    def getAlbumCovers(self):
        global SMOOTHSCROLLENABLED,SCROLLENABLED
        if len(albumArray)<12:
            SMOOTHSCROLLENABLED=False
        if len(albumArray)<12:
            SCROLLENABLED=False
        self.font = pygame.font.Font(None,16)
        for album in albumArray:
            loadok=0

    def retrieveImageFromNet(self, imageName, filename):
        global socketOk,coverlocation
        urladdress="http://images.search.yahoo.com/search/images?"
        imageSearch=string.replace(imageName,"_"," ")
        imageSearch=string.replace(imageSearch,":"," ")
        
        imageSearch=string.replace(imageSearch,"?"," ")
        imageSearch=string.replace(imageSearch,"/"," ")
        imageSearch=string.replace(imageSearch,"-"," ")
        imageSearch=string.replace(imageSearch,"~"," ")
        imageSearch=string.replace(imageSearch,"(1)","")
        imageSearch=string.replace(imageSearch,"(2)","")
        imageSearch=string.replace(imageSearch,"(3)","")
        imageSearch=string.replace(imageSearch,"(4)","")
        if (socketOk and filename.find("NOARTIST")==-1 and filename.find("UNKNOWN")==-1):
            params = {'p':imageSearch}            
            txdata = urllib.urlencode(params)
            urladdress=urladdress+txdata+"&ei=UTF-8"
            #print "opening " + urladdress
            found=False
            try:
                sock = urllib.urlopen(urladdress)                
                htmlSource = sock.read()
            except:
                print "retrieveImageFromNet(): unable to get socket"
                
                print sys.exc_info()[0]
                socketOk=False
            if socketOk:
                try:                
                    imagelocationStart=htmlSource.find('Go to fullsize image')+28
                    if (imagelocationStart>28):
                        imagelocationend=htmlSource.find('"',imagelocationStart)
                        imagelocation=htmlSource[imagelocationStart:imagelocationend]
                        
                        urllib.urlretrieve(imagelocation, filename)
                        found=True
    
                    sock.close()
                    return found
                except:
                    print "retrieveImageFromNet(): Problem saving file :" + filename
                    print sys.exc_info()[0]
                    
                    return False



    def retrieveImageFromNetMSN(self, imageName, filename):
        global socketOk,coverlocation
        urladdress="http://search.msn.com/images/results.aspx?"
        imageSearch=string.replace(imageName,"_"," ")
        imageSearch=string.replace(imageSearch,":"," ")
        
        imageSearch=string.replace(imageSearch,"?"," ")
        imageSearch=string.replace(imageSearch,"/"," ")
        imageSearch=string.replace(imageSearch,"-"," ")
        imageSearch=string.replace(imageSearch,"~"," ")
        imageSearch=string.replace(imageSearch,"["," ")
        imageSearch=string.replace(imageSearch,"]"," ")
        imageSearch=string.replace(imageSearch,"(1)","")
        imageSearch=string.replace(imageSearch,"(2)","")
        imageSearch=string.replace(imageSearch,"(3)","")
        imageSearch=string.replace(imageSearch,"(4)","")
        imageSearch=str(imageSearch)
        print "URL:" +imageSearch
        imagelocation=""
        if (socketOk and filename.find("NOARTIST")==-1 and filename.find("UNKNOWN")==-1):
            params = {'q':imageSearch}            
            txdata="unknown"
            try:
                txdata = urllib.urlencode(params)
            except:
                print "ERROR IN URL PARAMS:" + params
            
            urladdress=urladdress+txdata+"&FORM=QBIR"
            print "opening " + urladdress
            found=False
            try:
                sock = urllib.urlopen(urladdress)
                htmlSource = sock.read()
            except:
                print "retrieveImageFromNetMSN(): unable to get socket" + urladdress
                print sys.exc_info()[0]
                socketOk=False
            if socketOk:
                try:
                    imagelocationStart=htmlSource.find('thumbnail')-52
                    imagelocationStart=htmlSource.find('src="',imagelocationStart)+5
                    #print imagelocationStart
                    if (imagelocationStart>28):
                        imagelocationend=htmlSource.find('"',imagelocationStart)
                        imagelocation=htmlSource[imagelocationStart:imagelocationend]
                        urllib.urlretrieve(imagelocation, filename)
                        found=True
    
                    sock.close()
                    return found
                except:
                    print "retrieveImageFromNetMSN(): Problem saving file :" + filename
                    print "url :" + imagelocation
                    
                    print  sys.exc_info()[0]
                    socketOk=False
                    return False


class MainBackground:
    topx = 10
    topy = 7
    rect = Rect(10, 7 , 750, 450)
    def __init__(self):
        self.background = pygame.Surface(SCREENRECT.size).convert()
        self.makebg()
    def makebg(self):
        self.background.blit(self.image, (0, 0))


def showPosEvent(event):
    print 'Widget=%s X=%s Y=%s' % (event.widget, event.x, event.y)


def clearScreen():
    global mainbg
    #black = (0,0,0)
    #screen.fill(black)
    screen.blit(mainbg.background, (0, 0))

def globalReflection():
    global shine, SHINEX, SHINEY, SHINEVX,SHINEVY
    #Shine out. 
    if (SMOOTHSCROLLENABLED and VIDEOSMOOTHSCROLLENABLED):
      if (viewMode==ALBUMLISTVIEW or viewMode==VIDEOLISTVIEW) and buttonDown==1:
        screen.blit(shine, (pygame.mouse.get_pos()[0]-10, pygame.mouse.get_pos()[1]-20))
        SHINEX=pygame.mouse.get_pos()[0]
        SHINEY=pygame.mouse.get_pos()[1]
        SHINEVY=0
        SHINEVX=0
    
    rect = Rect((0, 400, 800, 40))
    image = pygame.Surface(rect.size)
    image.blit(pygame.display.get_surface(), (0, 0), rect)
    image=pygame.transform.flip(image, 0, 1)
    image.set_alpha(70)    
    screen.blit(image, (0,440))
    
def updateCovers():
    for i in artArray:
        i.update()
    for i in artArray:
        i.newDraw()
    albumButton.newDraw()
    #progressButton.newDraw()
    queuecountButton.newDraw()
    #playAlbumButton.newDraw()
    shuffleButton.newDraw()
    songButton.newDraw()
    globalReflection()

def updateClips():
    for i in clipArray:
        i.update()
    for i in clipArray:
        i.newDraw()
    albumButton.newDraw()
    #progressButton.newDraw()
    queuecountButton.newDraw()
    #playAlbumButton.newDraw()
    shuffleButton.newDraw()
    songButton.newDraw()
    globalReflection()
        

def explodeAlbums():
    global mouseMoved, dragXStart, dragSpeedX
    print "Exploding"
    j=1
    while j<7:
        clearScreen()
        for i in artArray:
            i.moveOut(j)
        globalReflection()
        pygame.display.flip()
        time.sleep(0.01)
        j=j+1
    dragXStart=0
    mouseMoved=0
    dragSpeedX=0
    queuecountButton.setVisible()
    progressButton.setVisible()
    songButton.setInvisible()
    
    
    
def showPNAlbums():
    global selectedArtArrayId
    global artArray
    print "ALBUMS"+str(selectedArtArrayId)
    #PREVIOUS

    if selectedArtArrayId>0 and selectedArtArrayId<len(artArray):
        artArray[selectedArtArrayId-1].rect.centerx=80
        artArray[selectedArtArrayId-1].rect.bottom=218
        visible.add(artArray[selectedArtArrayId-1])

    if selectedArtArrayId>2:
        artArray[selectedArtArrayId-2].rect.centerx=0
        artArray[selectedArtArrayId-2].rect.bottom=35
        visible.add(artArray[selectedArtArrayId-2])

    #NEXT
    if selectedArtArrayId<(len(artArray)-1):
        artArray[selectedArtArrayId].rect.centerx=0
        artArray[selectedArtArrayId].rect.bottom=390
        visible.add(artArray[selectedArtArrayId])

def setAlbumContentView():
    global viewModeToBe, viewMode, listButton, songlister,albumButton,nowPlayingAlbum

    global changed
    global cdClicked
    global songItems
    global songlister, visible

    desetCurrentPlayMode()
    clearScreen()
    pygame.display.flip()
    #progressButton.setInvisible()
    progressButton.setVisible()        
    queuecountButton.setVisible()
    songButton.setInvisible()
    playAlbumButton.setVisible()
    
    viewModeToBe=ALBUMCONTENTVIEW
    #albumButton.setAlbum()
    listButton.setVisible()                
    targetAlbum=nowPlayingAlbum    
    visible.add(songlister)
    songlister.setAlbum(artArray[targetAlbum].image,albumArtistArray[targetAlbum], albumArray[targetAlbum],targetAlbum)
    cdClicked=1
    changed=1
    visible.add(songlister)

def setAlbumListView():
    global viewModeToBe, viewMode, listButton, songlister, albumButton,songButton
    
    global changed
    global cdClicked
    global songItems
    global songlister, visible
    global dragXStart, mouseMoved, dragSpeedX

    #desetCurrentPlayMode()
    listButton.setInvisible()
    progressButton.setInvisible()
    queuecountButton.setInvisible()
    playAlbumButton.setInvisible()
    songButton.setVisible()
    i=0
    while i<30:
        visible.remove(songItems[i])
        i=i+1
    
    visible.remove(songlister)    
    viewModeToBe=ALBUMLISTVIEW
    viewMode=ALBUMLISTVIEW                        
    clearScreen()    
    updateCovers()
    pygame.display.flip()
    
    dragXStart=0
    mouseMoved=0
    dragSpeedX=0

    
def setVideoListView():
    global viewModeToBe, viewMode, listButton, songlister, dragSpeedX, dragXStart,mouseYMoved
    desetCurrentPlayMode()
    viewModeToBe=VIDEOLISTVIEW
    viewMode=VIDEOLISTVIEW   
    playAlbumButton.setInvisible()                     
    visible.remove(songlister)
    progressButton.setInvisible()
    i=0
    while i<30:
        visible.remove(songItems[i])
        i=i+1
    
    dragSpeedX=0
    dragXStart=0
    mouseYMoved=0
    updateClips()
    pygame.display.flip()

def setCurrentPlayMode():
    global progressButton, viewModeToBe, viewMode, listButton, songlister, albumButton
    progressButton.setVisible()        
    clearScreen()
    pygame.display.flip()
    listButton.setInvisible()
    #albumButton.setVisible()
    
    visible.remove(songlister)    
    viewModeToBe=ALBUMPLAYVIEW
    viewMode=ALBUMPLAYVIEW
    

def desetCurrentPlayMode():
    global progressButton, viewModeToBe, listButton, songlister
    #progressButton.setInvisible()        
    clearScreen()
    pygame.display.flip()
    
def showInfo(infoString, infoImage=None):
    global mainfont
    notificationItem=bgsheet.imgat((0, 562, 231, 75), -1)
    infoString=string.replace(infoString,"_"," ")
    print "info:" +infoString
    
    if len(infoString)>0:            
        infoStringArray=infoString.split(" ")
        lineNumber=0
        linePart=""
        for stringPart in infoStringArray:
            if len(linePart+stringPart)<30:
                linePart=linePart+stringPart+" "
            else:
                test=mainfont.render(linePart, 1, MAINFONTCOLOR)
                
                notificationItem.blit(test, (10,(10+lineNumber*18)))
                linePart=stringPart+" "
                lineNumber=lineNumber+1
        if len(stringPart)>0:
            test=mainfont.render(linePart, 1, MAINFONTCOLOR)
            
            notificationItem.blit(test, (10,(10+lineNumber*18)))
            linePart=stringPart
            
    screen.blit(notificationItem,(200, 200))
    if infoImage !=None:
        screen.blit(infoImage,(300,280))
    pygame.display.flip()
    
    
def handleDrag(dragSpeedX):
    if dragSpeedX>250:
        dragSpeedX=0
    if dragSpeedX<-250:
        dragSpeedX=0
    
    if dragSpeedX>100:
        dragSpeedX=100
    elif dragSpeedX<-100:
        dragSpeedX=-100
    elif dragSpeedX>10:
        dragSpeedX=dragSpeedX-2
    elif dragSpeedX<-10:
        dragSpeedX=dragSpeedX+2
    elif dragSpeedX>1:
        dragSpeedX=dragSpeedX-1
    elif dragSpeedX<-1:
        dragSpeedX=dragSpeedX+1
    else:
        dragSpeedX=0
    return dragSpeedX

def main():
    global selectedCD
    global cdClicked
    global filelist
    global albumlist
    global albumart
    global albumArray
    global albumArtistArray
    global artistlist
    global artArray
    global viewMode
    global viewModeToBe
    global songlist
    global songlister
    global startX
    global mouseMoved
    global mouseYMoved
    global buttonDown
    global buttonPressed
    global arrowPressed
    global visible
    global mp
    global mIn
    global mplayerOut
    global songBg
    global songItems
    global changed
    global pauseAlbumImage
    global playAlbumButton
    global playAlbumImage
    global albumButton
    global shuffleButton
    global listButton
    global notificationItem
    
    global queuecountButton
    global bgsheet
    global screen
    global PLAYPOSSIBLE
    global ISMAEMO
    global NOT_MAC
    global mainbg
    global shuffleImage
    global noshuffleImage
    global shuffleRect
    global shuffle
    global shuffleClicked
    global playSelected
    global bgsheet
    global MAINFONTCOLOR
    global MAINFONTBGCOLOR
    global mouseReleased
    global lastMouseReleased
    global VIDEOSMOOTHSCROLLENABLED
    global lastSongPosition
    global device
    global screen
    global winstyle
    global progressButton
    global songPosition
    global covers
    global songButton
    global shine
    global clearNeeded
    global SHINEX
    
    if ISMAEMO:
        device.display_blanking_pause()
        print "making charging monitor"
        monitor=BatteryMonitor()
    
    buttonPressed=0
    font = pygame.font.Font(None,22)


    cdbgimagelocation="data/test.png"
    bgimagelocation="data/bg.png"
    shinelocation="data/shine.png"
    if (os.path.exists("/usr/share/pixmaps/bg.png")):
        bgimagelocation="/usr/share/pixmaps/bg.png"
        shinelocation="/usr/share/pixmaps/shine.png"
    #print bgimagelocation

    if len(sys.argv) > 1 :
        bgimagelocation=string.replace(bgimagelocation,"bg.png","bg2.png")
    bgsheet= SpriteSheet(bgimagelocation)


    # left border - 0, right border - 1,
    # special left border - 2, special right border - 3
    # create the background
    MainBackground.image=bgsheet.imgat((0, 0, 800, 480), -1)
    mainbg = MainBackground()
    clearScreen()
    cdbgsheet = bgsheet.imgat((703, 490, 125, 160), -1)
    notificationItem=bgsheet.imgat((0, 562, 231, 75), -1)
    shine=pygame.image.load(shinelocation)
    all = pygame.sprite.RenderUpdates()
    visible = pygame.sprite.RenderUpdates()
    covers = pygame.sprite.RenderUpdates()
    clips = pygame.sprite.RenderUpdates()
    ControlButton.image=bgsheet.imgat((202, 492,64, 64), -1)
    ControlButton.containers=all, visible

    queuecountButton=ControlButton(20,418,"QUEUE")
    queuecountButton.setImage(bgsheet.imgat((20, 380, 132, 38), -1))
    queuecountButton.background=bgsheet.imgat((20, 380, 132, 38), -1)
    queuecountButton.altbackground=bgsheet.imgat((448, 489, 132, 38), -1)
    queuecountButton.setContinuousMode()
    queuecountButton.setInvisible()


    songButton=ControlButton(243,50,"ALBUM")
    songButton.setImage(bgsheet.imgat((243, 10, 270, 40), -1))
    songButton.background=(bgsheet.imgat((243, 10, 270, 40), -1))        
    songButton.setInvisible()
    
    
    #exitButton=ControlButton(0,50,"EXIT")
    #exitButton.setImage(bgsheet.imgat((0, 10, 70, 40), -1))        
    #exitButton.setInvisible()

    nextButton=ControlButton(620,50,"NEXT")
    nextButton.setImage(bgsheet.imgat((620, 10, 70, 40), -1))        
    nextButton.setInvisible()

    previousButton=ControlButton(590,50,"PREVIOUS")
    previousButton.setImage(bgsheet.imgat((590, 10, 70, 40), -1))        
    previousButton.setInvisible()


    progressButton=ControlButton(243,50,"PROGRESS")
    progressButton.setImage(bgsheet.imgat((0, 665, 324, 27), -1))
    progressButton.background=bgsheet.imgat((0, 665, 324, 27), -1)
    progressButton.activeBackground=bgsheet.imgat((0, 637, 324, 27), -1)
    progressButton.setInvisible()
    #progressButton.setVisible()

    MAINFONTCOLOR=bgsheet.sheet.get_at((100,512))
    ALTFONTCOLOR=bgsheet.sheet.get_at((100,534))
    #MAINFONTBGCOLOR=notificationItem.get_at((40,10))
    MAINFONTBGCOLOR=bgsheet.sheet.get_at((300,300))
    
    
    showInfo("Scanning memory cards...")
    
    
    songprocessor=SongProcessor()
    processtart=time.time()    
    songprocessor.getMusicFiles()
    if ISMAEMO: device.display_blanking_pause()
    print "music files took:" + str(time.time()-processtart)    
    
    showInfo("Reading music information from ID tags...")    
    songprocessor.getIDTags()
    
    #showInfo("GETTING MUSIC FROM DB...")    
    #songprocessor.getIDTagsFromDB()
    
    if ISMAEMO: device.display_blanking_pause()
    print "music+id tags took:" + str(time.time()-processtart)
    
    #IF USER HAS NO ALBUMS, LET IT BE KNOWN AND QUIT
    if (len(filelist)<1):        
        showInfo("No albums found. UKMP will now exit")        
        time.sleep(5)
        pygame.quit()

    showInfo("LOADING COVERS ("+str(len(albumArtistArray))+" Total)")        

    songprocessor.getAlbumCovers()

    
    listButton=ControlButton(0,70,"LIST")
    listButton.setImage(bgsheet.imgat((0, 0, 70, 70), -1))
    listButton.setInvisible()
    
    #albumImage=bgsheet.imgat((655, 80, 89, 114), -1)
    albumButton=ControlButton(183,70,"ALBUM_NO")
    #albumButton.setImage(albumImage)    
    albumButton.setInvisible()

    #MUSIC/MOVIES
    musicImage=bgsheet.imgat((70,0, 65, 62), -1)
    movieImage=bgsheet.imgat((140,0, 65, 62), -1)

    musicButton=ControlButton(140,18,"MUSIC")
    musicButton.setImage(musicImage)
    musicButton.rect=pygame.Rect(140,18, 65 ,62)

    movieButton=ControlButton(70,0,"MOVIE")
    movieButton.setImage(movieImage)
    movieButton.rect=pygame.Rect(70,0, 65 ,62)

    #at the moment, images don't need to be visible
    visible.remove (musicButton)
    visible.remove (movieButton)
    #SHUFFLE
    shuffleImage=bgsheet.imgat((254, 489, 52, 35), -1)
    noshuffleImage=bgsheet.imgat((700, 13, 52, 35), -1)

    shuffleButton=ControlButton(700,13,"SHUFFLE")
    shuffleButton.setImage(noshuffleImage)
    shuffleButton.setButton(700,48,"SHUFFLE")
    shuffleButton.isVisible=True

    playAlbumImage=bgsheet.imgat((415,39, 35, 35), -1)
    pauseAlbumImage=bgsheet.imgat((315,491, 35, 35), -1)

    playAlbumButton=ControlButton(105,340,"PLAY")
    playAlbumButton.image=playAlbumImage
    playAlbumButton.rect=pygame.Rect(105,337, 40 ,40)
    playAlbumButton.setInvisible()
    
    #art = pygame.sprite.RenderUpdates()
    SongItem.image=bgsheet.imgat((331, 562, 231, 75), -1)
    SongItem.background=bgsheet.imgat((331, 562, 231, 75), -1)
    SongItem.activeImage=bgsheet.imgat((0, 562, 231, 75), -1)
    SongItem.containers=all, visible

    i=0
    while i<30:
        songItems.append(SongItem(mainbg,i))
        songItems[i].image=bgsheet.imgat((331, 562, 231, 75), -1)
        songItems[i].activeImage=SongItem.activeImage
        visible.remove(songItems[i])
        i=i+1
    
    
    
    SongList.image = bgsheet.imgat((ALBUMNAMESTARTX,ALBUMNAMESTARTY, 450, 35), -1)
    SongList.background = bgsheet.imgat((ALBUMNAMESTARTX,ALBUMNAMESTARTY, 450, 35), -1)
    SongList.containers=all
    songlister=SongList(mainbg,songItems)
    songlister.rect.left=ALBUMNAMESTARTX
    songlister.rect.top=ALBUMNAMESTARTY

    VideoClip.image = cdbgsheet
    VideoClip.containers=all,visible,clips
    clipfilename=coverlocation+"UNKNOWN_UNKNOWN.jpg"

    if len(clipList)<12:
        VIDEOSMOOTHSCROLLENABLED=False
        print "Too few videoclips, smooth scrolldisabled"

    clipList.sort()
    i=0
    for clipname in clipList:
        clipArray.append(VideoClip(mainbg, i+1))
        #clipArray[i].image = bgsheet.imgat((703, 490, VIDEOCOVERWIDTH, 160), -1)
        clipArray[i].image = bgsheet.imgat((303, 280, VIDEOCOVERWIDTH, 200), -1)
        
        filepath=clipname.split("/")
        cliptitle=filepath[len(filepath)-1]
        clipArray[i].setClip(load_image(clipfilename),cliptitle, i,0,clipname)
        
        i=i+1


    CoverArt.image = cdbgsheet
    CoverArt.containers = all,visible,covers
    i=0
    processtart=time.time()
    
    
    for albumname in albumArray:
        filename=getCoverArtThumbFileName(albumname)
        imageLoadedFromNet=False
        
        try:
            test=os.path.exists(filename)
            if not test:
                songprocessor.getAlbumCover(i)
                imageLoadedFromNet=True
                test=os.path.exists(filename)
        except:
            #Something really wrong with some album name
            print "main(): album information not ok for album:" + albumname
            songprocessor.getAlbumCover(i)
            try:
                test=os.path.exists(filename)
            except:
                filename=coverlocation+"NOARTIST.jpg"
                albumArtistArray[i]="UNKNOWN"
                albumArray[i]="UNKNOWN"
                albumname="UNKNOWN"

        artArray.append(CoverArt(mainbg,i+1))
        artArray[i].image = bgsheet.imgat((303, 280, ALBUMWIDTH, 200), -1)
        
        #artArray[i].image=cdbgsheet.copy()

        if (len(filename)==0 or not os.path.exists(filename)):
            artArray[i].setAlbum(load_image(filename),albumArtistArray[i],albumname, i,0,filename)
            artArray[i].setunknown()
            print "setting as unknown2 "+filename
        else:
            if IMAGECACHINUSE and  os.path.exists(filename+".cache.tga"):
                artArray[i].setAlbum(load_image(filename+".cache.tga"),albumArtistArray[i],albumname, i,1,filename)
            else:
                artArray[i].setAlbum(load_image(filename),albumArtistArray[i],albumname, i,0,filename)
        if (filename.find("NOARTIST")>-1):
            artArray[i].setunknown()
            print "setting as unknown1"

        if imageLoadedFromNet or (i%4==0 or i>(len(albumArray)-5)):

            
            text=str(i+1)+"/"+str(len(albumArray))+":"+albumArray[i]
            if imageLoadedFromNet:
                text="Downloading cover from Internet:" + text
            text=text[0:100]
            
            showInfo(text, artArray[i].image)
            
        #print "added album cover: " + filename
        i=i+1
    print "Covers art:" + str(time.time()-processtart)
    clearScreen()
    pygame.display.flip()
    clock = pygame.time.Clock()
    changed=1
    buttonDown=0
    buttonWasDown=0
    startX=0
    artDragXStart=0
    idleStart=0
    lastSongPosition=0
    dirty=""
    dragXStart=0
    mouseYMoved=0
    mouseMoved=0
    startY=0
    lastY=0
    lastX=0
    startX=0
    upActive=False
    downActive=False
    escActive=False
    leftActive=False
    rightActive=False
    buttonDownStart=0
    loopstart=0
    mouseReleased=0
    lastMouseReleased=0
    dragSpeedX=0
    
    queuecountButton.setContinuousMode()
    gc.collect()

    while 1:
        if ISMAEMO and keepBacklightOn: device.display_blanking_pause()
        loopstart=time.time()
        if escActive and (time.time()-buttonDownStart)>1.5:
            return

        # get input
        arrowPressed=0
        buttonPressed=0
        clearNeeded=0
        playSelected=False
        thisY=0
        if dragSpeedX!=0:
            dragSpeedX=handleDrag(dragSpeedX)
        if buttonDown==0 and dragSpeedX!=0 :
            if viewMode!=ALBUMCONTENTVIEW:
                mouseMoved=mouseMoved+dragSpeedX
                changed=1
                arrowPressed=1
                if (mouseMoved>ALBUMYSCROLL ):
                    selectedCD=selectedCD-2
                    dragXStart=dragXStart-ALBUMYSCROLL
                    mouseMoved=mouseMoved-ALBUMYSCROLL
                if (mouseMoved<-ALBUMYSCROLL):
                    selectedCD=selectedCD+2
                    dragXStart=dragXStart+ALBUMYSCROLL
                    mouseMoved=mouseMoved+ALBUMYSCROLL
            else:
                dragXStart=0
                #mouseMoved=0
                dragSpeedX=0

        #Handle playing multiple files
        if (songlister.playOn==1):
            if NOT_MAC:
                songPosition = songlister.getPercentPosition()
                progressButton.setProgress(songPosition)
                

                #print songPosition
                test1,test2,test3=songlister.player.get_state()
                if test2!=gst.STATE_PLAYING  or (lastSongPosition>10 and songPosition<1) or (lastSongPosition>98 and lastSongPosition==songPosition):
                    songlister.next()
                    lastSongPosition=0
                else:
                    lastSongPosition=songPosition
            else:
                progressButton.setProgress(pygame.mixer.music.get_pos()/1000)
                if pygame.mixer.music.get_pos()==-1:
                    #a quick wait to see if it's *just* starting to play the music.
                    time.sleep(0.4)                    
                    if pygame.mixer.music.get_pos()==-1:
                #print "songPosition"+ str(pygame.mixer.music.get_pos())
                        songlister.next()

        for event in pygame.event.get():

                #print event
            if (event.type == KEYUP):
                downActive=False
                upActive=False
                leftActive=False
                rightActive=False
                escActive=False
                if (event.key == K_LEFT and (time.time()-buttonDownStart<0.6)):
                    songlister.previous()
                    clearNeeded=1
                if (event.key == K_RIGHT and (time.time()-buttonDownStart<0.6)):
                    songlister.next()
                    clearNeeded=1

                #buttonDownStart must be at the end so that we can decide on the next song / seek policy
                buttonDownStart=0

            if (event.type == KEYDOWN):
                buttonDownStart=time.time()

                if (event.key == K_LEFT):
                    leftActive=True
                if (event.key == K_RIGHT):
                    rightActive=True

                if (event.key == K_DOWN ):
                    downActive=True

                if (event.key == K_UP ):
                    upActive=True

                #back button pressed
                if (event.key == K_ESCAPE):
                    dragXStart=0
                    mouseMoved=0
                    dragSpeedX=0
                    escActive=True
                    
                    if (viewMode==ALBUMLISTVIEW):
                        setVideoListView()                        
                    elif (viewMode==VIDEOLISTVIEW):                                                
                        #setCurrentPlayMode()
                        setAlbumContentView()
                    elif (viewMode==ALBUMPLAYVIEW):                        
                        setAlbumContentView()
                        
                    elif (viewMode==ALBUMCONTENTVIEW):
                        setAlbumListView()
                        
                if (event.key == K_RETURN):
                    if (playAlbumButton.buttonType=="PAUSE"): songlister.pause()
                    else: songlister.play()
                    changed=1
                if (event.key == K_F7):
                    #Add volume
                    vol=songlister.getVolume()
                    print "volume:" + str(vol)
                    #vol=vol+10
                    vol=vol + 0.5
                    songlister.setVolume(vol)

                if (event.key == K_F8):
                    #Decrease volume
                    vol=songlister.getVolume()
                    print "volume:" + str(vol)
                    #vol=vol-10
                    vol=vol - 0.5
                    songlister.setVolume(vol)

                if (event.key == K_F6):
                    if (winstyle==1):
                        winstyle=FULLSCREEN
                    else:
                        winstyle=1
                    screen = pygame.display.set_mode(SCREENRECT.size, winstyle, bestdepth)
                    clearScreen()
                    pygame.display.flip()
                    changed=1

            if (event.type == MOUSEBUTTONUP):
                lastMouseReleased=mouseReleased
                mouseReleased=time.time()
                if (event.button<4):
                    dragXStart=0
                    if (startX-pygame.mouse.get_pos()[0]<10 and startX-pygame.mouse.get_pos()[0]>-10): buttonPressed=1
                    buttonDown=0
                    changed=1
                    #mouseYMoved=0

            if (event.type == MOUSEMOTION ):
                if (pygame.mouse.get_pos()[1]>70 and buttonDown==1):
                    #print ('travelled: '+str((startY-pygame.mouse.get_pos()[1])))
                    if  (lastX-pygame.mouse.get_pos()[0])!=0:
                        dragSpeedX=lastX-pygame.mouse.get_pos()[0]
                    mouseMoved=(dragXStart-pygame.mouse.get_pos()[0])
                    lastX=pygame.mouse.get_pos()[0]
                    
                    mouseYMoved=pygame.mouse.get_pos()[1]
                    lastY=pygame.mouse.get_pos()[1]
                    changed=1
                    if (mouseMoved>ALBUMYSCROLL):
                        print "mouseMoved"+str(mouseMoved)
                        if (viewMode!=ALBUMCONTENTVIEW):
                            #print "Scrolling left"
                            selectedCD=selectedCD-2
                            changed=1
                            arrowPressed=1
                            buttonPressed=0
                            dragXStart=dragXStart-ALBUMYSCROLL
                            mouseMoved=0
                    if (mouseMoved<-ALBUMYSCROLL):
                        if (viewMode!=ALBUMCONTENTVIEW):
                            #print "Scrolling right"
                            selectedCD=selectedCD+2
                            changed=1
                            arrowPressed=1
                            buttonPressed=0
                            dragXStart=dragXStart+ALBUMYSCROLL
                            mouseMoved=0

            if (event.type == MOUSEBUTTONDOWN):
                changed=0
                if (event.button==1):
                    startX=pygame.mouse.get_pos()[0]
                    startY=pygame.mouse.get_pos()[1]
                    dragXStart=pygame.mouse.get_pos()[0]+mouseMoved
                    buttonDown=1
                #Handle Mouse WHEEL. Just as if arrow button was pressed
                if (event.button==4):
                    if (viewMode!=ALBUMCONTENTVIEW):
                        selectedCD=selectedCD+2
                        changed=1
                        arrowPressed=1
                        buttonPressed=0
                if (event.button==5):
                    if (viewMode!=ALBUMCONTENTVIEW):
                        #print "Scrolling down"
                        selectedCD=selectedCD-2
                        changed=1
                        arrowPressed=1
                        buttonPressed=0

            if event.type == QUIT :
                return

        if leftActive and buttonDownStart>0:
            if (time.time()-buttonDownStart)>0.6:
                songlister.seekBackward()
        if rightActive and buttonDownStart>0:
            if (time.time()-buttonDownStart)>0.6:
                songlister.seekForward()
        if upActive:
            if (viewMode!=ALBUMCONTENTVIEW):
                dragSpeedX=-40
            if (viewMode==ALBUMCONTENTVIEW):
                songlister.showNextAlbum()
                changed=1
                arrowPressed=1
        if downActive:
            if (viewMode!=ALBUMCONTENTVIEW):
                dragSpeedX=40
            if (viewMode==ALBUMCONTENTVIEW):
                songlister.showPreviousAlbum()
                changed=1
                arrowPressed=1
        #print "event handler loopTime:" + str(time.time()-loopstart)
        if (changed==1):
            idleStart=time.time()
            cdClicked=0
            if (buttonPressed==1):
                all.update()
                if (cdClicked==0):
                    if (shuffleClicked==1 ):
                        shuffleClicked=0
                        dirty = visible.draw(screen)                        
                        #pygame.display.update(dirty)
                        globalReflection()
                        progressButton.newDraw()
                        pygame.display.flip()
                    visible.update()
                    #print "****Not drawing ..."
                else:
                    all.update()
                    dirty = visible.draw(screen)
                    globalReflection()
                    progressButton.newDraw()
                    pygame.display.flip()
                    
                                        
            else:
                
                if (clearNeeded==1 or event.type != MOUSEMOTION or viewMode==ALBUMCONTENTVIEW):
                    clearScreen()
                if event.type == MOUSEMOTION and viewMode==ALBUMLISTVIEW and (SMOOTHSCROLLENABLED or VIDEOSMOOTHSCROLLENABLED):
                    #fast draw for smooth scroll
                    updateCovers()
                    globalReflection()
                    pygame.display.flip()

                elif event.type == MOUSEMOTION and viewMode==VIDEOLISTVIEW and (SMOOTHSCROLLENABLED or VIDEOSMOOTHSCROLLENABLED):
                    updateClips()
                    globalReflection()
                    pygame.display.flip()

                elif (dragSpeedX!=0) and viewMode==ALBUMLISTVIEW:
                    updateCovers()
                    globalReflection()
                    pygame.display.flip()
                else:
                    all.update()
                    dirty = visible.draw(screen)                    
                    globalReflection()
                    pygame.display.flip()
                    
            changed=0
        else:
            if (dragSpeedX!=0) :
                    if viewMode==ALBUMLISTVIEW: 
                        updateCovers()
                    elif viewMode==VIDEOLISTVIEW: 
                        updateClips()
                    globalReflection()
                    pygame.display.flip()
        if viewMode!=viewModeToBe:
            dragSpeedX=0
            dragXStart=0
            mouseMoved=0
            mouseYMoved=0
            
        viewMode=viewModeToBe

        # cap the framerate
        #print "Total loop time:" + str(time.time()-loopstart)
        if dragSpeedX==0:
            timediff=(time.time()-idleStart)
            if (timediff>500):
                time.sleep(4)
            elif (timediff>300):
                time.sleep(2)
            elif (timediff>115):
                time.sleep(1)
            elif (timediff>15):
                time.sleep(0.5)
            elif (timediff>3):
                time.sleep(0.2)
            elif not ISMAEMO: time.sleep(0.05)

if __name__ == '__main__': main()
